//+------------------------------------------------------------------+
//|                                                     RMDialog.mqh |
//|                                                          Mikhail |
//|                                              textyping@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "Mikhail"
#property link      "textyping@yandex.ru"
#property strict

#include <Controls\RM-Dialog3.mqh>
#include <Controls\Button.mqh>
#include <Controls\Label.mqh>
#include <Controls\RM-ComboBox.mqh>
#include <Controls\Edit.mqh>
#include <Controls\RM-RadioButton.mqh>
#include <Controls\RM-SpinEdit1.mqh>
#include <Controls\CheckBox.mqh>
#include <Controls\RM-DatePicker2.mqh>
#include <Controls\Panel.mqh>
#include <Controls\BmpButton.mqh>

#resource "\\Images\\BuyButton.bmp"
#resource "\\Images\\SellButton.bmp"

int buttonDeleteRight;

//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
//--- indents and gaps
#define INDENT_LEFT                         (3)       // indent from left (with allowance for border width)
#define INDENT_TOP                          (3)       // indent from top (with allowance for border width)
#define INDENT_RIGHT                        (3)       // indent from right (with allowance for border width)
#define INDENT_BOTTOM                       (3)       // indent from bottom (with allowance for border width)
#define BUTTONS_GAP_X                       (4)       // gap by X coordinate
#define CONTROLS_GAP_X                      (4)       // gap by X coordinate
#define CONTROLS_GAP_Y                      (4)       // gap by Y coordinate
#define CONTROLS_GAP_Y_BUTTONS              (4)       // gap by Y coordinate buttons
//--- for buttons
#define BUTTON_WIDTH                        (120)     // size by X coordinate
#define BUTTON_WIDTH2                       (115)     // size by X coordinate
#define BUTTON_HEIGHT                       (30)      // size by Y coordinate
#define BUTTON_BUY_SELL_WIDTH               (80)      // size by X coordinate
#define BUTTON_BUY_SELL_HEIGHT              (38)      // size by Y coordinate
#define BUTTON_ACTIONS_WIDTH                (100)     // size by X coordinate
#define BUTTON_ACTIONS_HEIGHT               (20)      // size by X coordinate
#define BUTTON_TEXT_FONTSIZE                (8)       // buttons fontsize
#define BUTTON_MORE_ACTIONS_WIDTH           (160)     // size by X coordinate
#define BUTTON_MORE_ACTIONS_HEIGHT          (20)      // size by y coordinate
#define BUTTON_MORE_ACTIONS_FONTSIZE        (8)       // buttons more actions fontsize
#define BUTTON_MODIFY_WIDTH                 (100)     // size by X coordinate
//--- for labels
#define LABEL_TRADE_WIDTH                   (35)      // size by X coordinate
#define LABEL_MODIFY_TRADE_WIDTH            (77)      // size by X coordinate
#define LABELS_TRADE_GAP_X                  (10)      // gap by Y coordinate
#define LABEL_WIDTH                         (100)     // size by X coordinate
#define LABEL_WIDTH2                        (60)      // size by X coordinate
#define LABEL_WIDTH3                        (90)      // size by X coordinate
#define LABEL_HEIGHT                        (18)      // size by Y coordinate
#define LABEL_HEIGHT3                       (12)      // size by Y coordinate
#define LABEL_SPREAD_WIDTH                  (20)      // size by X coordinate
#define LABEL_SPREAD_HEIGHT                 (15)      // size by Y coordinate
#define LABEL_GAP_Y                         (5)       // size by Y coordinate
//--- for the combo box
#define COMBO_WIDTH                         (144)     // size by X coordinate
#define COMBO_WIDTH1                        (122)     // size by X coordinate
#define COMBO_HEIGHT                        (18)      // size by Y coordinate
#define COMBO_PENDING_WIDTH                 (130)     // size by X coordinate
//--- for the spin edit
#define SPIN_EDIT_WIDTH                     (74)      // size by X coordinate
#define SPIN_EDIT_HEIGHT                    (18)      // size by Y coordinate
//--- for the edit
#define EDIT_SPREAD_WIDTH                   (50)      // size by X coordinate
#define EDIT_SPREAD_HEIGHT                  (30)      // size by Y coordinate
#define EDIT_SPREAD_GAP_Y                   (4)       // gap by Y coordinate
#define EDIT_DATETIME_WIDTH                 (170)     // size by X coordinate
#define EDIT_HEIGHT                         (20)      // size by Y coordinate
#define EDIT_TIME_WIDTH                     (20)      // size by X coordinate
#define EDIT_TIME_HEIGHT                    (20)      // size by Y coordinate
#define EDIT_DOTS_WIDTH                     (9)       // size by X coordinate
#define INDENT_HOURS                        (90)      // indent from left to hours
//--- for the radio button
#define RADIO_WIDTH                         (100)     // size by X coordinate
#define RADIO_HEIGHT                        (18)      // size by Y coordinate
#define RADIO_ONOFF_WIDTH                   (50)      // size by X coordinate
#define RADIO_ONOFF_HEIGHT                  (18)      // size by Y coordinate
//--- for the check box
#define CHECK_BOX_WIDTH                     (20)      // size by X coordinate
#define CHECK_BOX_HEIGHT                    (20)      // size by Y coordinate
//--- for the date picker
#define DATE_PICKER_WIDTH                   (208)      // size by X coordinate
#define DATE_PICKER_HEIGHT                  (20)       // size by Y coordinate
//--- for the rectangle more actions
#define RECT_WIDTH                          (170)      // size by X coordinate
#define RECT_HEIGHT                         (174)      // size by Y coordinate
#define RECT_INDENT_TOP                     (5)        // indent by Y coordinate
#define RECT_INDENT_LEFT                    (5)        // indent by X coordinate
//--- colors for trade labels
#define COLOR_ON                            (C'255,255,255')         // color when label pressed
#define COLOR_OFF                           (C'100,100,125')         // color when label unpressed
//--- for rectangles
#define RECTANGLE_TRADE_HEIGHT              (1)        // size by Y coordinate
#define RECTANGLE_LOT_SIZE_WIDTH            (233)      // size by X coordinate
#define INDENT_IN_RECTANGLE_LEFT            (6)        // indent from left in rectangle
#define INDENT_IN_RECTANGLE_TOP             (6)        // indent from top in rectangle

//+------------------------------------------------------------------+
//| Class CPanelDialog                                               |
//| Usage: main dialog of the SimplePanel application                |
//+------------------------------------------------------------------+
class CPanelDialog : public CAppDialog
  {
public:
   CLabel            m_labelTradeClicked;             // the label Trade Clicked object
   CLabel            m_labelTradeUnclicked;           // the label Trade Unclicked object
   CLabel            m_labelModifyTradeClicked;       // the label Modify Trade Clicked object
   CLabel            m_labelModifyTradeUnclicked;     // the label Modify Trade Unclicked object
   CPanel            m_rectangleTrade;                // the rectangle Trade object
   CPanel            m_rectangleModifyTrade;          // the rectangle Modify Trade object
   CPanel            m_rectangleLotSize;              // the rectangle Lot Size object
   CComboBox         m_comboboxLotSizeDropdown;       // the combo box Lot Size object
   CSpinEdit         m_spinEditLotSize;               // the spin edit Lot Size object
   CPanel            m_rectangleBuySell;              // the rectangle Buy Sell object 
   CBmpButton        m_buttonBuy;                     // the button Buy object
   CBmpButton        m_buttonSell;                    // the button Sell object
   CEdit             m_editSpread;                    // the edit Spread object
   CLabel            m_labelSpread;                   // the label Spread object
   CLabel            m_labelSpreadValue;              // the label Spread Value object
   CLabel            m_labelBuyAskValue;              // the label Buy Ask Value object
   CLabel            m_labelSellBidValue;             // the label Sell Bid Value object
   CPanel            m_rectangleSlTp;                 // the rectangle SL TP object 
   CRadioButton      m_radioNormal;                   // the radio button Normal object
   CRadioButton      m_radioReverse;                  // the radio button Reverse object
   CComboBox         m_comboboxStopLoss;              // the combo box Stop Loss object
   CSpinEdit         m_spinEditStopLoss;              // the spin edit Stop Loss object
   CComboBox         m_comboboxTakeProfit;            // the combo box Take Profit object
   CSpinEdit         m_spinEditTakeProfit;            // the spin edit Take Profit object
   CPanel            m_rectangleBeTs;                 // the rectangle BE TS object 
   CLabel            m_labelBreakeven;                // the label Smart Breakeven object
   CSpinEdit         m_spinEditBreakeven;             // the spin edit Breakeven object
   CLabel            m_labelTrailingStop;             // the label Trailing Stop object
   CSpinEdit         m_spinEditTrailingStop;          // the spin edit Trailing Stop object
   CLabel            m_labelTrailingStopDistance;     // the label Trailing Stop Distance object
   CSpinEdit         m_spinEditTrailingStopDistance;  // the spin edit Trailing Stop Distance object
   CButton           m_buttonMoreActions;             // the button More Actions object
   CLabel            m_labelPendingOrder;             // the label Pending Order object
   CPanel            m_rectanglePending;              // the rectangle Pending object 
   CComboBox         m_comboboxDistance;              // the combo box Distance object
   CSpinEdit         m_spinEditDistance;              // the spin edit Distance object
   CComboBox         m_comboboxPendingType;           // the combo box Pending Type object
   CButton           m_buttonPlacePending;            // the button Place Pending object
   CPanel            m_rectanglePreview;              // the rectangle Preview object 
   CLabel            m_labelPreview;                  // the label Preview object
   CComboBox         m_comboboxOrdersType;            // the combo box Lot Size object
   CRadioButton      m_radioOn;                       // the radio button On object
   CRadioButton      m_radioOff;                      // the radio button Off object
   CLabel            m_labelLossOnSL;                 // the label Loss On SL object
   CLabel            m_labelLossOnSLValue;            // the label Loss On SL value object
   CLabel            m_labelProfitOnTP;               // the label Profit On TP object
   CLabel            m_labelProfitOnTPValue;          // the label Profit On TP value object
   CLabel            m_labelLotSize1;                 // the label Lot Size object
   CLabel            m_labelLotSize1Value;            // the label Lot Size value object
   CLabel            m_labelMargin;                   // the label Margin object
   CLabel            m_labelMarginValue;              // the label Margin value object
   
   CPanel            m_rectangle;                     // the rectangle More Action object
   CButton           m_buttonCloseAllTrades;          // the button Close All Trades object
   CButton           m_buttonDeleteAllPending;        // the button Delete All Pending object
   CButton           m_buttonClose50Volume;           // the button Close 50% of volume object
   CButton           m_buttonCloseAllLoss;            // the button Close all in loss object
   CButton           m_buttonCloseAllProfit;          // the button Close all in profit object
   CButton           m_buttonCloseAllBuy;             // the button Close all Buy object
   CButton           m_buttonCloseAllSell;            // the button Close All Sell object

   CPanel            m_rectangleOrderDetails;         // the rectangle Order Details object
   CLabel            m_labelSelectOrder;              // the label Select Order object
   CComboBox         m_comboboxSelectOrder;           // the combo box Select Order object
   CLabel            m_labelOrderDetails;             // the label Order Details object
   CLabel            m_labelSymbol;                   // the label Symbol object
   CLabel            m_labelAction;                   // the label Action object
   CLabel            m_labelSize;                     // the label Size object
   CLabel            m_labelOpenPrice;                // the label Open Price object
   CLabel            m_labelTakeProfit;               // the label Take Profit object
   CLabel            m_labelStopLoss;                 // the label Stop Loss object
   CLabel            m_labelComment;                  // the label Comment object
   CLabel            m_labelTrailStop;                // the label Trailing Stop object
   CLabel            m_labelTrailStopDistance;        // the label Trailing Stop Distance object
   CLabel            m_labelBreakEven;                // the label Break Even object
   CLabel            m_labelOrderExpires;             // the label Order Expires object
   CLabel            m_labelSymbolValue;              // the label Symbol Value object
   CLabel            m_labelActionValue;              // the label Action Value object
   CLabel            m_labelSizeValue;                // the label Size Value object
   CLabel            m_labelOpenPriceValue;           // the label Open Price Value object
   CLabel            m_labelTakeProfitValue;          // the label Take Profit Value object
   CLabel            m_labelStopLossValue;            // the label Stop Loss Value object
   CLabel            m_labelCommentValue;             // the label Comment Value object
   CLabel            m_labelTrailStopValue;           // the label Trailing Stop Value object
   CLabel            m_labelTrailStopDistanceValue;   // the label Trailing Stop Distance Value object
   CLabel            m_labelBreakEvenValue;           // the label Break Even Value object
   CLabel            m_labelOrderExpiresValue;        // the label Order Expires Value object
   CPanel            m_rectangleModifyOrder;          // the rectangle Modify Order object
   CLabel            m_labelModifyOrder;              // the label Modify Order object
   CComboBox         m_comboboxSL;                    // the combo box Stop Loss object
   CSpinEdit         m_spinEditSL;                    // the spin edit Stop Loss object
   CComboBox         m_comboboxTP;                    // the combo box Take Profit object
   CSpinEdit         m_spinEditTP;                    // the spin edit Take Profit object
   CLabel            m_labelBreakeven2;               // the label Smart Breakeven2 object
   CSpinEdit         m_spinEditBreakeven2;            // the spin edit Breakeven2 object
   CLabel            m_labelTrailingStop2;            // the label Trailing Stop2 object
   CSpinEdit         m_spinEditTrailingStop2;         // the spin edit Trailing Stop2 object
   CLabel            m_labelTrailingStopDistance2;    // the label Trailing Stop Distance2 object
   CSpinEdit         m_spinEditTrailingStopDistance2; // the spin edit Trailing Stop Distance2 object
   CLabel            m_labelOpenPrice2;               // the label Open Price2 object
   CSpinEdit         m_spinEditOpenPrice2;            // the spin edit Open Price2 object
   CButton           m_buttonModifyOrder;             // the button Modify Order object
   CButton           m_buttonClose50;                 // the button Modify Order object
   CButton           m_buttonClose11;                 // the button Modify Order object
   CButton           m_buttonDelete;                  // the button Modify Order object
   
   bool              tradeMode;                       // true - panel in Trade mode, false - panel in Modify Trades mode

//public:
                     CPanelDialog(void);
                    ~CPanelDialog(void);
   //--- create
   virtual bool      Create(const long chart,const string name,const int subwin,const int x1,const int y1,const int x2,const int y2);
   //--- chart event handler
   virtual bool      OnEvent(const int id,const long &lparam,const double &dparam,const string &sparam);
   
   void              correction(void);
//protected:
   //--- create dependent controls
   
   bool              CreateLabelTradeClicked(void);
   bool              CreateLabelTradeUnclicked(void);
   bool              CreateLabelModifyTradeClicked(void);
   bool              CreateLabelModifyTradeUnclicked(void);
   bool              CreateRectangleTrade(void);
   bool              CreateRectangleModifyTrade(void);
   bool              CreateRectangleLotSize(void);
   bool              CreateComboboxLotSize(void);
   bool              CreateSpinEditLotSize(void);
   bool              CreateRectangleBuySell(void);
   bool              CreateButtonBuy(void);
   bool              CreateButtonSell(void);
   bool              CreateEditSpread(void);
   bool              CreateLabelSpread(void);
   bool              CreateLabelSpreadValue(void);
   bool              CreateLabelBuyAskValue(void);
   bool              CreateLabelSellBidValue(void);
   bool              CreateRectangleSlTp(void);
   bool              CreateRadioNormal(void);
   bool              CreateRadioReverse(void);
   bool              CreateComboboxStopLoss(void);
   bool              CreateSpinEditStopLoss(void);
   bool              CreateComboboxTakeProfit(void);
   bool              CreateSpinEditTakeProfit(void);
   bool              CreateRectangleBeTs(void);
   bool              CreateLabelBreakeven(void);
   bool              CreateSpinEditBreakeven(void);
   bool              CreateLabelTrailingStop(void);
   bool              CreateSpinEditTrailingStop(void);
   bool              CreateLabelTrailingStopDistance(void);
   bool              CreateSpinEditTrailingStopDistance(void);
   bool              CreateButtonMoreActions(void);
   bool              CreateLabelPendingOrder(void);
   bool              CreateRectanglePending(void);
   bool              CreateComboboxDistance(void);
   bool              CreateSpinEditDistance(void);
   bool              CreateComboboxPendingType(void);
   bool              CreateButtonPlacePending(void);
   bool              CreateRectanglePreview(void);
   bool              CreateLabelPreview(void);
   bool              CreateComboboxOrdersType(void);
   bool              CreateRadioOn(void);
   bool              CreateRadioOff(void);
   bool              CreateLabelLossOnSL(void);
   bool              CreateLabelLossOnSLValue(void);
   bool              CreateLabelProfitOnTP(void);
   bool              CreateLabelProfitOnTPValue(void);
   bool              CreateLabelLotSize1(void);
   bool              CreateLabelLotSize1Value(void);
   bool              CreateLabelMargin(void);
   bool              CreateLabelMarginValue(void);
   
   bool              CreateRect(void);
   bool              CreateButtonCloseAllTrades(void);
   bool              CreateButtonDeleteAllPending(void);
   bool              CreateButtonClose50Volume(void);
   bool              CreateButtonCloseAllLoss(void);
   bool              CreateButtonCloseAllProfit(void);
   bool              CreateButtonCloseAllBuy(void);
   bool              CreateButtonCloseAllSell(void);
   
   bool              CreateRectangleOrderDetails(void);
   bool              CreateLabelSelectOrder(void);
   bool              CreateComboboxSelectOrder(void);
   bool              CreateLabelOrderDetails(void);
   bool              CreateLabelSymbol(void);
   bool              CreateLabelAction(void);
   bool              CreateLabelSize(void);
   bool              CreateLabelOpenPrice(void);
   bool              CreateLabelTakeProfit(void);
   bool              CreateLabelStopLoss(void);
   bool              CreateLabelComment(void);
   bool              CreateLabelTrailStop(void);
   bool              CreateLabelTrailStopDistance(void);
   bool              CreateLabelBreakEven(void);
   bool              CreateLabelOrderExpires(void);
   bool              CreateLabelSymbolValue(void);
   bool              CreateLabelActionValue(void);
   bool              CreateLabelSizeValue(void);
   bool              CreateLabelOpenPriceValue(void);
   bool              CreateLabelTakeProfitValue(void);
   bool              CreateLabelStopLossValue(void);
   bool              CreateLabelCommentValue(void);
   bool              CreateLabelTrailStopValue(void);
   bool              CreateLabelTrailStopDistanceValue(void);
   bool              CreateLabelBreakEvenValue(void);
   bool              CreateLabelOrderExpiresValue(void);
   bool              CreateRectangleModifyOrder(void);
   bool              CreateLabelModifyOrder(void);
   bool              CreateComboboxSL(void);
   bool              CreateSpinEditSL(void);
   bool              CreateComboboxTP(void);
   bool              CreateSpinEditTP(void);
   bool              CreateLabelBreakeven2(void);
   bool              CreateSpinEditBreakeven2(void);
   bool              CreateLabelTrailingStop2(void);
   bool              CreateSpinEditTrailingStop2(void);
   bool              CreateLabelTrailingStopDistance2(void);
   bool              CreateSpinEditTrailingStopDistance2(void);
   bool              CreateLabelOpenPrice2(void);
   bool              CreateSpinEditOpenPrice2(void);
   bool              CreateButtonModifyOrder(void);
   bool              CreateButtonClose50(void);
   bool              CreateButtonClose11(void);
   bool              CreateButtonDelete(void);
   
   bool              createTradeControls(void);

   //--- handlers of the dependent controls events

   void              OnClickLabelModifyTradeUnclicked(void);
   void              OnClickLabelTradeUnclicked(void);
   void              OnChangeComboLotSize(void);
   void              OnChangeSpinEditLotSize(void);
   void              OnChangeComboStopLoss(void);
   void              OnChangeSpinEditStopLoss(void);
   void              OnChangeComboTakeProfit(void);
   void              OnChangeSpinEditTakeProfit(void);
   void              OnClickButtonBuy(void);
   void              OnClickButtonSell(void);
   void              OnClickButtonMoreActions(void);
   void              OnChangeComboboxDistance(void);
   void              OnChangeSpinEditDistance(void);
   void              OnChangeRadioNormal(void);
   void              OnChangeRadioReverse(void);
   void              EndEditDatePicker(void);
   void              OnChangeComboboxPendingType(void);
   void              OnClickButtonPlacePending(void);
   void              OnChangeRadioOn(void);
   void              OnChangeRadioOff(void);
   void              OnChangeComboboxSelectOrder(void);
   void              OnClickButtonModifyOrder(void);
   void              OnClickButtonClose50(void);
   void              OnClickButtonClose11(void);
   void              OnClickButtonDelete(void);
   void              OnChangeComboSL(void);
   void              OnChangeComboTP(void);
   bool              OnDefault(const int id,const long &lparam,const double &dparam,const string &sparam);

  };
//+------------------------------------------------------------------+
//| Event Handling                                                   |
//+------------------------------------------------------------------+
EVENT_MAP_BEGIN(CPanelDialog)
ON_EVENT(ON_CLICK,m_labelModifyTradeUnclicked,OnClickLabelModifyTradeUnclicked)
ON_EVENT(ON_CLICK,m_labelTradeUnclicked,OnClickLabelTradeUnclicked)
ON_EVENT(ON_CHANGE,m_comboboxLotSizeDropdown,OnChangeComboLotSize)
ON_EVENT(ON_CHANGE,m_spinEditLotSize,OnChangeSpinEditLotSize)
ON_EVENT(ON_CHANGE,m_comboboxStopLoss,OnChangeComboStopLoss)
ON_EVENT(ON_CHANGE,m_spinEditStopLoss,OnChangeSpinEditStopLoss)
ON_EVENT(ON_CHANGE,m_comboboxTakeProfit,OnChangeComboTakeProfit)
ON_EVENT(ON_CHANGE,m_spinEditTakeProfit,OnChangeSpinEditTakeProfit)
ON_EVENT(ON_CLICK,m_buttonBuy,OnClickButtonBuy)
ON_EVENT(ON_CLICK,m_buttonSell,OnClickButtonSell)
ON_EVENT(ON_CHANGE,m_radioNormal,OnChangeRadioNormal)
ON_EVENT(ON_CHANGE,m_radioReverse,OnChangeRadioReverse)
ON_EVENT(ON_CLICK,m_buttonMoreActions,OnClickButtonMoreActions)
   
ON_EVENT(ON_CHANGE,m_comboboxDistance,OnChangeComboboxDistance)
ON_EVENT(ON_CHANGE,m_spinEditDistance,OnChangeSpinEditDistance)
ON_EVENT(ON_CHANGE,m_comboboxPendingType,OnChangeComboboxPendingType)
ON_EVENT(ON_CLICK,m_buttonPlacePending,OnClickButtonPlacePending)
ON_EVENT(ON_CHANGE,m_radioOn,OnChangeRadioOn)
ON_EVENT(ON_CHANGE,m_radioOff,OnChangeRadioOff)
ON_EVENT(ON_CLICK,m_buttonModifyOrder,OnClickButtonModifyOrder)
ON_EVENT(ON_CHANGE,m_comboboxSelectOrder,OnChangeComboboxSelectOrder)
ON_EVENT(ON_CLICK,m_buttonClose50,OnClickButtonClose50)
ON_EVENT(ON_CLICK,m_buttonClose11,OnClickButtonClose11)
ON_EVENT(ON_CLICK,m_buttonDelete,OnClickButtonDelete)

ON_EVENT(ON_CHANGE,m_comboboxSL,OnChangeComboSL)
ON_EVENT(ON_CHANGE,m_comboboxTP,OnChangeComboTP)

ON_OTHER_EVENTS(OnDefault)
EVENT_MAP_END(CAppDialog)

//+------------------------------------------------------------------+
//| Constructor                                                      |
//+------------------------------------------------------------------+
CPanelDialog::CPanelDialog(void)
  {
   tradeMode = true;
  }
//+------------------------------------------------------------------+
//| Destructor                                                       |
//+------------------------------------------------------------------+
CPanelDialog::~CPanelDialog(void)
  {
  }
//+------------------------------------------------------------------+
//| Create                                                           |
//+------------------------------------------------------------------+
bool CPanelDialog::Create(const long chart,const string name,const int subwin,const int x1,const int y1,const int x2,const int y2)
  {
   if(!CAppDialog::Create(chart,name,subwin,x1,y1,x2,y2))
      return(false);
//--- create dependent controls
   if(!CreateLabelTradeClicked())
      return(false);
   if(!CreateLabelTradeUnclicked())
      return(false);
   if(!CreateLabelModifyTradeClicked())
      return(false);
   if(!CreateLabelModifyTradeUnclicked())
      return(false);
   if(!CreateRectangleTrade())
      return(false);
   if(!CreateRectangleModifyTrade())
      return(false);
   if(!CreateRectangleLotSize())
      return(false);
   if(!CreateComboboxLotSize())
      return(false);
   if(!CreateSpinEditLotSize())
      return(false);
   if(!CreateRectangleBuySell())
      return(false);
   if(!CreateButtonBuy())
      return(false);
   if(!CreateButtonSell())
      return(false);
   if(!CreateEditSpread())
      return(false);
   if(!CreateLabelSpread())
      return(false);
   if(!CreateLabelSpreadValue())
      return(false);
   if(!CreateLabelBuyAskValue())
      return(false);
   if(!CreateLabelSellBidValue())
      return(false);
   if(!CreateRectangleSlTp())
      return(false);
   if(!CreateRadioNormal())
      return(false); 
   if(!CreateRadioReverse())
      return(false);
   if(!CreateComboboxStopLoss())
      return(false);
   if(!CreateSpinEditStopLoss())
      return(false); 
   if(!CreateComboboxTakeProfit())
      return(false);
   if(!CreateSpinEditTakeProfit())
      return(false); 
   if(!CreateRectangleBeTs())
      return(false); 
   if(!CreateLabelBreakeven())
      return(false); 
   if(!CreateSpinEditBreakeven())
      return(false); 
   if(!CreateLabelTrailingStop())
      return(false); 
   if(!CreateSpinEditTrailingStop())
      return(false); 
   if(!CreateLabelTrailingStopDistance())
      return(false); 
   if(!CreateSpinEditTrailingStopDistance())
      return(false);

   if(!CreateButtonMoreActions())
      return(false); 
   if(!CreateLabelPendingOrder())
      return(false); 
   if(!CreateRectanglePending())
      return(false); 
   if(!CreateComboboxDistance())
      return(false);
   if(!CreateSpinEditDistance())
      return(false);
   if(!CreateComboboxPendingType())
      return(false);
   if(!CreateButtonPlacePending())
      return(false);
   if(!CreateRectanglePreview())
      return(false);
   if(!CreateLabelPreview())
      return(false);
   if(!CreateComboboxOrdersType())
      return(false);
   if(!CreateRadioOn())
      return(false);
   if(!CreateRadioOff())
      return(false);
   if(!CreateLabelLossOnSL())
      return(false);
   if(!CreateLabelLossOnSLValue())
      return(false);
   if(!CreateLabelProfitOnTP())
      return(false);
   if(!CreateLabelProfitOnTPValue())
      return(false);
   if(!CreateLabelLotSize1())
      return(false);
   if(!CreateLabelLotSize1Value())
      return(false);
   if(!CreateLabelMargin())
      return(false);
   if(!CreateLabelMarginValue())
      return(false);
  
   if(!CreateRectangleOrderDetails())
      return(false); 
   if(!CreateLabelSelectOrder())
      return(false);
   if(!CreateComboboxSelectOrder())
      return(false);
   if(!CreateLabelOrderDetails())
      return(false);
   if(!CreateLabelSymbol())
      return(false);
   if(!CreateLabelAction())
      return(false);
   if(!CreateLabelSize())
      return(false);
   if(!CreateLabelOpenPrice())
      return(false);
   if(!CreateLabelTakeProfit())
      return(false);
   if(!CreateLabelStopLoss())
      return(false);
   if(!CreateLabelComment())
      return(false);
   if(!CreateLabelTrailStop())
      return(false);
   if(!CreateLabelTrailStopDistance())
      return(false);
   if(!CreateLabelBreakEven())
      return(false);
   if(!CreateLabelOrderExpires())
      return(false);
   if(!CreateLabelSymbolValue())
      return(false);
   if(!CreateLabelActionValue())
      return(false);
   if(!CreateLabelSizeValue())
      return(false);
   if(!CreateLabelOpenPriceValue())
      return(false);
   if(!CreateLabelTakeProfitValue())
      return(false);
   if(!CreateLabelStopLossValue())
      return(false);
   if(!CreateLabelCommentValue())
      return(false);
   if(!CreateLabelTrailStopValue())
      return(false);
   if(!CreateLabelTrailStopDistanceValue())
      return(false);
   if(!CreateLabelBreakEvenValue())
      return(false);
   if(!CreateLabelOrderExpiresValue())
      return(false);
   if(!CreateRectangleModifyOrder())
      return(false);
   if(!CreateLabelModifyOrder())
      return(false);
   if(!CreateComboboxSL())
      return(false);
   if(!CreateSpinEditSL())
      return(false);
   if(!CreateComboboxTP())
      return(false);
   if(!CreateSpinEditTP())
      return(false);
   if(!CreateLabelBreakeven2())
      return(false);
   if(!CreateSpinEditBreakeven2())
      return(false);
   if(!CreateLabelTrailingStop2())
      return(false);
   if(!CreateSpinEditTrailingStop2())
      return(false);
   if(!CreateLabelTrailingStopDistance2())
      return(false);
   if(!CreateSpinEditTrailingStopDistance2())
      return(false);
   if(!CreateLabelOpenPrice2())
      return(false);
   if(!CreateSpinEditOpenPrice2())
      return(false);
   if(!CreateButtonModifyOrder())
      return(false);
   if(!CreateButtonClose50())
      return(false);
   if(!CreateButtonClose11())
      return(false);
   if(!CreateButtonDelete())
      return(false);

//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Correction                                                       |
//+------------------------------------------------------------------+
void CPanelDialog::correction(void)
   {
     Delete(m_labelTradeUnclicked);
     m_labelTradeUnclicked.Destroy();
     Delete(m_labelModifyTradeClicked);
     m_labelModifyTradeClicked.Destroy();
     Delete(m_rectangleModifyTrade);
     m_rectangleModifyTrade.Destroy();
     Delete(m_rectangleOrderDetails);
     m_rectangleOrderDetails.Destroy();
     Delete(m_labelSelectOrder);
     m_labelSelectOrder.Destroy();
     Delete(m_comboboxSelectOrder);
     m_comboboxSelectOrder.Destroy();
     Delete(m_labelOrderDetails);
     m_labelOrderDetails.Destroy();
     Delete(m_labelSymbol);
     m_labelSymbol.Destroy();
     Delete(m_labelAction);
     m_labelAction.Destroy();
     Delete(m_labelSize);
     m_labelSize.Destroy();
     Delete(m_labelOpenPrice);
     m_labelOpenPrice.Destroy();
     Delete(m_labelTakeProfit);
     m_labelTakeProfit.Destroy();
     Delete(m_labelStopLoss);
     m_labelStopLoss.Destroy();
     Delete(m_labelComment);
     m_labelComment.Destroy();
     Delete(m_labelTrailStop);
     m_labelTrailStop.Destroy();
     Delete(m_labelTrailStopDistance);
     m_labelTrailStopDistance.Destroy();
     Delete(m_labelBreakEven);
     m_labelBreakEven.Destroy();
     Delete(m_labelOrderExpires);
     m_labelOrderExpires.Destroy();
     Delete(m_labelSymbolValue);
     m_labelSymbolValue.Destroy();
     Delete(m_labelActionValue);
     m_labelActionValue.Destroy();
     Delete(m_labelSizeValue);
     m_labelSizeValue.Destroy();
     Delete(m_labelOpenPriceValue);
     m_labelOpenPriceValue.Destroy();
     Delete(m_labelTakeProfitValue);
     m_labelTakeProfitValue.Destroy();
     Delete(m_labelStopLossValue);
     m_labelStopLossValue.Destroy();
     Delete(m_labelCommentValue);
     m_labelCommentValue.Destroy();
     Delete(m_labelTrailStopValue);
     m_labelTrailStopValue.Destroy();
     Delete(m_labelTrailStopDistanceValue);
     m_labelTrailStopDistanceValue.Destroy();
     Delete(m_labelBreakEvenValue);
     m_labelBreakEvenValue.Destroy();
     Delete(m_labelOrderExpiresValue);
     m_labelOrderExpiresValue.Destroy();
     Delete(m_rectangleModifyOrder);
     m_rectangleModifyOrder.Destroy();
     Delete(m_labelModifyOrder);
     m_labelModifyOrder.Destroy();
     Delete(m_comboboxSL);
     m_comboboxSL.Destroy();
     Delete(m_spinEditSL);
     m_spinEditSL.Destroy();
     Delete(m_comboboxTP);
     m_comboboxTP.Destroy();
     Delete(m_spinEditTP);
     m_spinEditTP.Destroy();
     Delete(m_labelBreakeven2);
     m_labelBreakeven2.Destroy();
     Delete(m_spinEditBreakeven2);
     m_spinEditBreakeven2.Destroy();
     Delete(m_labelTrailingStop2);
     m_labelTrailingStop2.Destroy();
     Delete(m_spinEditTrailingStop2);
     m_spinEditTrailingStop2.Destroy();
     Delete(m_labelTrailingStopDistance2);
     m_labelTrailingStopDistance2.Destroy();
     Delete(m_spinEditTrailingStopDistance2);
     m_spinEditTrailingStopDistance2.Destroy();
     Delete(m_labelOpenPrice2);
     m_labelOpenPrice2.Destroy();
     Delete(m_spinEditOpenPrice2);
     m_spinEditOpenPrice2.Destroy();
     Delete(m_buttonModifyOrder);
     m_buttonModifyOrder.Destroy();
     Delete(m_buttonClose50);
     m_buttonClose50.Destroy();
     Delete(m_buttonClose11);
     m_buttonClose11.Destroy();
     Delete(m_buttonDelete);
     m_buttonDelete.Destroy();
     
   if (m_radioOn.State())
    {
     m_labelLossOnSL.Show();
     m_labelLossOnSLValue.Show();
     m_labelProfitOnTP.Show();
     m_labelProfitOnTPValue.Show();
     m_labelLotSize1.Show();
     m_labelLotSize1Value.Show();
     m_labelMargin.Show();
     m_labelMarginValue.Show();
    }
   else
    {
     m_labelLossOnSL.Hide();
     m_labelLossOnSLValue.Hide();
     m_labelProfitOnTP.Hide();
     m_labelProfitOnTPValue.Hide();
     m_labelLotSize1.Hide();
     m_labelLotSize1Value.Hide();
     m_labelMargin.Hide();
     m_labelMarginValue.Hide();
    }
    ObjectDelete(0, openPriceLine);
    ObjectDelete(0, openPriceLabel);
    ObjectDelete(0, slLine);
    ObjectDelete(0, tpLine);
   }
//+------------------------------------------------------------------+
//| Create the "Trade" clicked label                                 |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelTradeClicked(void)
  {
//--- coordinates
   int x1=INDENT_LEFT;
   int y1=INDENT_TOP;
   int x2=x1+LABEL_TRADE_WIDTH;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelTradeClicked.Create(m_chart_id,m_name+"LabelTradeClicked",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelTradeClicked.Text("Trade"))
      return(false);
   if(!Add(m_labelTradeClicked))
      return(false);
   m_labelTradeClicked.Color(COLOR_ON);
//--- succeed

   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Trade" unclicked label                               |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelTradeUnclicked(void)
  {
//--- coordinates
   int x1=INDENT_LEFT;
   int y1=INDENT_TOP;
   int x2=x1+LABEL_TRADE_WIDTH;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelTradeUnclicked.Create(m_chart_id,m_name+"LabelTradeUncklicked",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelTradeUnclicked.Text("Trade"))
      return(false);
   if(!Add(m_labelTradeUnclicked))
      return(false);
   m_labelTradeUnclicked.Color(COLOR_OFF);
//--- succeed

   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Modify Trade" clicked label                          |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelModifyTradeClicked(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+LABEL_TRADE_WIDTH+LABELS_TRADE_GAP_X;
   int y1=INDENT_TOP;
   int x2=x1+LABEL_MODIFY_TRADE_WIDTH;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelModifyTradeClicked.Create(m_chart_id,m_name+"LabelModifyTradeClicked",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelModifyTradeClicked.Text("Modify Trade"))
      return(false);
   if(!Add(m_labelModifyTradeClicked))
      return(false);
   m_labelModifyTradeClicked.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Modify Trade" unclicked label                        |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelModifyTradeUnclicked(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+LABEL_TRADE_WIDTH+LABELS_TRADE_GAP_X;
   int y1=INDENT_TOP;
   int x2=x1+LABEL_MODIFY_TRADE_WIDTH;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelModifyTradeUnclicked.Create(m_chart_id,m_name+"LabelModifyTradeUnlicked",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelModifyTradeUnclicked.Text("Modify Trade"))
      return(false);
   if(!Add(m_labelModifyTradeUnclicked))
      return(false);
   m_labelModifyTradeUnclicked.Color(COLOR_OFF);
//--- succeed

   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Trade" underscore label                              |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateRectangleTrade(void)
  {
//--- coordinates
   int x1=INDENT_LEFT;
   int y1=INDENT_TOP+LABEL_HEIGHT+CONTROLS_GAP_Y;
   int x2=x1+LABEL_TRADE_WIDTH;
   int y2=y1+RECTANGLE_TRADE_HEIGHT;
//--- create
   if(!m_rectangleTrade.Create(m_chart_id,m_name+"rectangleTrade",m_subwin,x1,y1,x2,y2))
      return(false);

   if(!Add(m_rectangleTrade))
      return(false);
   m_rectangleTrade.ColorBorder(COLOR_OFF);
   m_rectangleTrade.ColorBackground(COLOR_OFF);
//--- succeed

   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Modify Trade" underscore label                       |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateRectangleModifyTrade(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+LABEL_TRADE_WIDTH+LABELS_TRADE_GAP_X;
   int y1=INDENT_TOP+LABEL_HEIGHT+CONTROLS_GAP_Y;
   int x2=x1+LABEL_MODIFY_TRADE_WIDTH;
   int y2=y1+RECTANGLE_TRADE_HEIGHT;
//--- create
   if(!m_rectangleModifyTrade.Create(m_chart_id,m_name+"rectangleModifyTrade",m_subwin,x1,y1,x2,y2))
      return(false);

   if(!Add(m_rectangleModifyTrade))
      return(false);
   m_rectangleModifyTrade.ColorBorder(COLOR_OFF);
   m_rectangleModifyTrade.ColorBackground(COLOR_OFF);
//--- succeed

   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Lot Size" rectangle label                            |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateRectangleLotSize(void)
  {
//--- coordinates
   int x1=INDENT_LEFT;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+2*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT;
   int x2=x1+RECTANGLE_LOT_SIZE_WIDTH;
   int y2=y1+COMBO_HEIGHT+2*INDENT_IN_RECTANGLE_TOP;
//--- create
   if(!m_rectangleLotSize.Create(m_chart_id,m_name+"rectangleLotSize",m_subwin,x1,y1,x2,y2))
      return(false);

   if(!Add(m_rectangleLotSize))
      return(false);
   m_rectangleLotSize.ColorBorder(COLOR_OFF);
   m_rectangleLotSize.ColorBackground(MAIN_COLOR);
//--- succeed

   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Combo box Lot Size" label                            |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateComboboxLotSize(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+2*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+INDENT_IN_RECTANGLE_TOP;
   int x2=x1+COMBO_WIDTH;
   int y2=y1+COMBO_HEIGHT;
//--- create
   if(!m_comboboxLotSizeDropdown.Create(m_chart_id,m_name+"ComboboxLotSize",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_comboboxLotSizeDropdown))
      return(false);
//--- fill out with strings
   if(!m_comboboxLotSizeDropdown.AddItem("Risk (%)",0))
      return(false);
   if(!m_comboboxLotSizeDropdown.AddItem("Risk in USD ($)",1))
      return(false);
   if(!m_comboboxLotSizeDropdown.AddItem("Lot Size (Fixed)",2))
      return(false);
   if(!m_comboboxLotSizeDropdown.Select(2))
      return(false);
//   m_comboboxLotSizeDropdown.BackColor(clrBlack);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Spin Edit Lot Size" field                            |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateSpinEditLotSize(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+CONTROLS_GAP_X+COMBO_WIDTH+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+2*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+INDENT_IN_RECTANGLE_TOP;
   int x2=x1+SPIN_EDIT_WIDTH;
   int y2=y1+SPIN_EDIT_HEIGHT;
//--- create
   if(!m_spinEditLotSize.Create(m_chart_id,m_name+"spinEditLotSize",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_spinEditLotSize))
      return(false);
   m_spinEditLotSize.MaxValue(10000);
   m_spinEditLotSize.setDigits(lotsDigits);
   m_spinEditLotSize.Value(lot);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Buy Sell" rectangle label                            |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateRectangleBuySell(void)
  {
//--- coordinates
   int x1=INDENT_LEFT;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+3*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+COMBO_HEIGHT+2*INDENT_IN_RECTANGLE_TOP;
   int x2=x1+RECTANGLE_LOT_SIZE_WIDTH;
   int y2=y1+BUTTON_BUY_SELL_HEIGHT+2*INDENT_IN_RECTANGLE_TOP;
//--- create
   if(!m_rectangleBuySell.Create(m_chart_id,m_name+"rectangleBuySell",m_subwin,x1,y1,x2,y2))
      return(false);

   if(!Add(m_rectangleBuySell))
      return(false);
   m_rectangleBuySell.ColorBorder(COLOR_OFF);
   m_rectangleBuySell.ColorBackground(MAIN_COLOR);
//--- succeed

   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Button Buy" button                                   |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateButtonBuy(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+3*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+COMBO_HEIGHT+3*INDENT_IN_RECTANGLE_TOP;
   int x2=x1+BUTTON_BUY_SELL_WIDTH;
   int y2=y1+BUTTON_BUY_SELL_HEIGHT;
//--- create
   if(!m_buttonBuy.Create(m_chart_id,m_name+"ButtonBuy",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_buttonBuy.Text("Buy"))
      return(false);
   if(!Add(m_buttonBuy))
      return(false);
   m_buttonBuy.BmpNames("::Images\\BuyButton.bmp", "::Images\\BuyButton.bmp");
   m_buttonBuy.ColorBackground(clrGreen);
   m_buttonBuy.Locking(false);
   m_buttonBuy.Color(clrWhite);
   m_buttonBuy.Font("Arial Black");
   m_buttonBuy.FontSize(BUTTON_TEXT_FONTSIZE);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Button Sell" button                                  |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateButtonSell(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+BUTTON_BUY_SELL_WIDTH + 3*CONTROLS_GAP_X+EDIT_SPREAD_WIDTH+INDENT_IN_RECTANGLE_LEFT-1;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+3*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+COMBO_HEIGHT+3*INDENT_IN_RECTANGLE_TOP;
   int x2=x1+BUTTON_BUY_SELL_WIDTH;
   int y2=y1+BUTTON_BUY_SELL_HEIGHT;
//--- create
   if(!m_buttonSell.Create(m_chart_id,m_name+"ButtonSell",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_buttonSell.Text("Sell"))
      return(false);
   if(!Add(m_buttonSell))
      return(false);
   m_buttonSell.BmpNames("::Images\\SellButton.bmp", "::Images\\SellButton.bmp");
   m_buttonSell.ColorBackground(clrOrangeRed);
   m_buttonSell.Locking(false);
   m_buttonSell.Color(clrWhite);
   m_buttonSell.Font("Arial Black");
   m_buttonSell.FontSize(BUTTON_TEXT_FONTSIZE);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Edit Spread" field                                   |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateEditSpread(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+BUTTON_BUY_SELL_WIDTH + CONTROLS_GAP_X+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+3*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+COMBO_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+EDIT_SPREAD_GAP_Y;
   int x2=x1+EDIT_SPREAD_WIDTH;
   int y2=y1+EDIT_SPREAD_HEIGHT;
//--- create
   if(!m_editSpread.Create(m_chart_id,m_name+"EditSpread",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_editSpread))
      return(false);
   m_editSpread.Text("");
   m_editSpread.ReadOnly(true);
   m_editSpread.TextAlign(ALIGN_CENTER);
   m_editSpread.ColorBackground(COLOR_COMBOBOX);
   m_editSpread.ColorBorder(COLOR_COMBOBOX);
   m_editSpread.Color(COLOR_OFF);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Spread" label                                        |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelSpread(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+BUTTON_BUY_SELL_WIDTH + CONTROLS_GAP_X+INDENT_IN_RECTANGLE_LEFT+11;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+3*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+COMBO_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+
   EDIT_SPREAD_GAP_Y;
   int x2=x1+LABEL_SPREAD_WIDTH;
   int y2=y1+LABEL_SPREAD_HEIGHT-5;
//--- create
   if(!m_labelSpread.Create(m_chart_id,m_name+"LabelSpread",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelSpread.Text("SPREAD"))
      return(false);
   if(!Add(m_labelSpread))
      return(false);
   m_labelSpread.Color(COLOR_OFF);
   m_labelSpread.FontSize(7);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Spread Value" label                                  |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelSpreadValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+BUTTON_BUY_SELL_WIDTH + CONTROLS_GAP_X+INDENT_IN_RECTANGLE_LEFT+20;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+4*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+COMBO_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+
   EDIT_SPREAD_GAP_Y+LABEL_SPREAD_HEIGHT-8;
   int x2=x1+LABEL_SPREAD_WIDTH;
   int y2=y1+LABEL_SPREAD_HEIGHT;
//--- create
   if(!m_labelSpreadValue.Create(m_chart_id,m_name+"LabelSpreadValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelSpreadValue.Text(IntegerToString(int(MarketInfo(_Symbol,MODE_SPREAD)))))
      return(false);
   if(!Add(m_labelSpreadValue))
      return(false);
   m_labelSpreadValue.Color(COLOR_OFF);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Buy Ask Value" label                                  |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelBuyAskValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+INDENT_IN_RECTANGLE_LEFT+35;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+4*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+COMBO_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+
   EDIT_SPREAD_GAP_Y+LABEL_SPREAD_HEIGHT-4;
   int x2=x1+LABEL_SPREAD_WIDTH;
   int y2=y1+LABEL_SPREAD_HEIGHT;
//--- create
   if(!m_labelBuyAskValue.Create(m_chart_id,m_name+"LabelBuyAskValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelBuyAskValue.Text(DoubleToString(MarketInfo(_Symbol,MODE_ASK), _Digits)))
      return(false);
   if(!Add(m_labelBuyAskValue))
      return(false);
   m_labelBuyAskValue.Color(clrWhite);
   m_labelBuyAskValue.FontSize(7);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Sell Bid Value" label                                  |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelSellBidValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+BUTTON_BUY_SELL_WIDTH+EDIT_SPREAD_WIDTH+2*CONTROLS_GAP_X+INDENT_IN_RECTANGLE_LEFT+40;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+4*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+COMBO_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+
   EDIT_SPREAD_GAP_Y+LABEL_SPREAD_HEIGHT-4;
   int x2=x1+LABEL_SPREAD_WIDTH;
   int y2=y1+LABEL_SPREAD_HEIGHT;
//--- create
   if(!m_labelSellBidValue.Create(m_chart_id,m_name+"LabelSellBidValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelSellBidValue.Text(DoubleToString(MarketInfo(_Symbol,MODE_BID), _Digits)))
      return(false);
   if(!Add(m_labelSellBidValue))
      return(false);
   m_labelSellBidValue.Color(clrWhite);
   m_labelSellBidValue.FontSize(7);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "SL TP" rectangle label                               |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateRectangleSlTp(void)
  {
//--- coordinates
   int x1=INDENT_LEFT;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+4*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+COMBO_HEIGHT+4*INDENT_IN_RECTANGLE_TOP
          +BUTTON_BUY_SELL_HEIGHT;
   int x2=x1+RECTANGLE_LOT_SIZE_WIDTH;
   int y2=y1+RADIO_HEIGHT+2*COMBO_HEIGHT+2*INDENT_IN_RECTANGLE_TOP+2*CONTROLS_GAP_Y;
//--- create
   if(!m_rectangleSlTp.Create(m_chart_id,m_name+"rectangleSlTp",m_subwin,x1,y1,x2,y2))
      return(false);

   if(!Add(m_rectangleSlTp))
      return(false);
   m_rectangleSlTp.ColorBorder(COLOR_OFF);
   m_rectangleSlTp.ColorBackground(MAIN_COLOR);
//--- succeed

   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Radio Button Normal" element                         |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateRadioNormal(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+4*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+COMBO_HEIGHT+5*INDENT_IN_RECTANGLE_TOP
          +BUTTON_BUY_SELL_HEIGHT;
   int x2=x1+RADIO_WIDTH;
   int y2=y1+RADIO_HEIGHT;
//--- create
   if(!m_radioNormal.Create(m_chart_id,m_name+"RadioNormal",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_radioNormal))
      return(false);
 //  m_radioNormal.Alignment(WND_ALIGN_WIDTH,0,0,0,0);
//--- fill out with strings
   if(!m_radioNormal.Text("Open Normal"))
      return(false);
   if(!m_radioNormal.State(true))
      return(false);
   
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Radio Button Reverse" element                        |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateRadioReverse(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+INDENT_IN_RECTANGLE_LEFT+RADIO_WIDTH+CONTROLS_GAP_X;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+4*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+COMBO_HEIGHT+5*INDENT_IN_RECTANGLE_TOP
          +BUTTON_BUY_SELL_HEIGHT;
   int x2=x1+RADIO_WIDTH+10;
   int y2=y1+RADIO_HEIGHT;
//--- create
   if(!m_radioReverse.Create(m_chart_id,m_name+"RadioReverse",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_radioReverse))
      return(false);
//   m_radioNormalReverse.Alignment(WND_ALIGN_WIDTH,0,0,0,0);
//--- fill out with strings
   if(!m_radioReverse.Text("Reverse&Open"))
      return(false);
   if(!m_radioReverse.State(false))
      return(false);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Combo box Stop Loss" label                           |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateComboboxStopLoss(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+5*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+COMBO_HEIGHT+5*INDENT_IN_RECTANGLE_TOP
          +BUTTON_BUY_SELL_HEIGHT+RADIO_HEIGHT;
   int x2=x1+COMBO_WIDTH;
   int y2=y1+COMBO_HEIGHT;
//--- create
   if(!m_comboboxStopLoss.Create(m_chart_id,m_name+"ComboboxStopLoss",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_comboboxStopLoss))
      return(false);
//--- fill out with strings
   if(!m_comboboxStopLoss.AddItem("Stop Loss in pips",0))
      return(false);
   if(!m_comboboxStopLoss.AddItem("Stop Loss at price",1))
      return(false);
   if(!m_comboboxStopLoss.Select(0))
      return(false);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Spin Edit Stop Loss" field                           |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateSpinEditStopLoss(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+INDENT_IN_RECTANGLE_LEFT+CONTROLS_GAP_X+COMBO_WIDTH;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+5*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+COMBO_HEIGHT+5*INDENT_IN_RECTANGLE_TOP
          +BUTTON_BUY_SELL_HEIGHT+RADIO_HEIGHT;
   int x2=x1+SPIN_EDIT_WIDTH;
   int y2=y1+SPIN_EDIT_HEIGHT;
//--- create
   if(!m_spinEditStopLoss.Create(m_chart_id,m_name+"spinEditStopLoss",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_spinEditStopLoss))
      return(false);
   m_spinEditStopLoss.MaxValue(100000);
   m_spinEditStopLoss.setDigits(digitsAfterDot);
   m_spinEditStopLoss.Value(StopLoss);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Combo box Take Profit" label                         |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateComboboxTakeProfit(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+6*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+2*COMBO_HEIGHT+5*INDENT_IN_RECTANGLE_TOP
          +BUTTON_BUY_SELL_HEIGHT+RADIO_HEIGHT;
   int x2=x1+COMBO_WIDTH;
   int y2=y1+COMBO_HEIGHT;
//--- create
   if(!m_comboboxTakeProfit.Create(m_chart_id,m_name+"ComboboxTakeProfit",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_comboboxTakeProfit))
      return(false);
//--- fill out with strings
   if(!m_comboboxTakeProfit.AddItem("Take Profit in pips",0))
      return(false);
   if(!m_comboboxTakeProfit.AddItem("Take Profit at price",1))
      return(false);
   if(!m_comboboxTakeProfit.AddItem("Take Profit at seconds",2))
      return(false);
   if(!m_comboboxTakeProfit.Select(0))
      return(false);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Edit Take Profit" field                              |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateSpinEditTakeProfit(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+INDENT_IN_RECTANGLE_LEFT+CONTROLS_GAP_X+COMBO_WIDTH;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+6*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+2*COMBO_HEIGHT+5*INDENT_IN_RECTANGLE_TOP
          +BUTTON_BUY_SELL_HEIGHT+RADIO_HEIGHT;
   int x2=x1+SPIN_EDIT_WIDTH;
   int y2=y1+SPIN_EDIT_HEIGHT;
//--- create
   if(!m_spinEditTakeProfit.Create(m_chart_id,m_name+"spinEditTakeProfit",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_spinEditTakeProfit))
      return(false);
   m_spinEditTakeProfit.MaxValue(100000);
   m_spinEditTakeProfit.setDigits(digitsAfterDot);
   m_spinEditTakeProfit.Value(TakeProfit);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "BE TS" rectangle label                               |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateRectangleBeTs(void)
  {
//--- coordinates
   int x1=INDENT_LEFT;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+7*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*COMBO_HEIGHT+6*INDENT_IN_RECTANGLE_TOP
          +BUTTON_BUY_SELL_HEIGHT+RADIO_HEIGHT;
   int x2=x1+RECTANGLE_LOT_SIZE_WIDTH;
   int y2=y1+3*COMBO_HEIGHT+2*INDENT_IN_RECTANGLE_TOP+2*CONTROLS_GAP_Y;
//--- create
   if(!m_rectangleBeTs.Create(m_chart_id,m_name+"rectangleBeTs",m_subwin,x1,y1,x2,y2))
      return(false);

   if(!Add(m_rectangleBeTs))
      return(false);
   m_rectangleBeTs.ColorBorder(COLOR_OFF);
   m_rectangleBeTs.ColorBackground(MAIN_COLOR);
//--- succeed

   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Smart Breakeven" label                         |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelBreakeven(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+7*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*COMBO_HEIGHT+7*INDENT_IN_RECTANGLE_TOP
          +BUTTON_BUY_SELL_HEIGHT+RADIO_HEIGHT;
   int x2=x1+LABEL_WIDTH;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelBreakeven.Create(m_chart_id,m_name+"LabelBreakeven",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelBreakeven.Text("Smart Breakeven"))
      return(false);
   if(!Add(m_labelBreakeven))
      return(false);
   m_labelBreakeven.Color(clrWhite);
 //  m_labelBreakeven.Font("Arial Black");

//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Edit Breakeven" field                                |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateSpinEditBreakeven(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+INDENT_IN_RECTANGLE_LEFT+CONTROLS_GAP_X+COMBO_WIDTH;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+7*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*COMBO_HEIGHT+7*INDENT_IN_RECTANGLE_TOP
          +BUTTON_BUY_SELL_HEIGHT+RADIO_HEIGHT;
   int x2=x1+SPIN_EDIT_WIDTH;
   int y2=y1+SPIN_EDIT_HEIGHT;
//--- create
   if(!m_spinEditBreakeven.Create(m_chart_id,m_name+"spinEditBreakeven",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_spinEditBreakeven))
      return(false);
   m_spinEditBreakeven.MaxValue(100);
   m_spinEditBreakeven.setDigits(1);
   m_spinEditBreakeven.Value(8);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Trailing Stop" label                           |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelTrailingStop(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+3*LABEL_HEIGHT+8*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*COMBO_HEIGHT+7*INDENT_IN_RECTANGLE_TOP
          +BUTTON_BUY_SELL_HEIGHT+RADIO_HEIGHT;
   int x2=x1+LABEL_WIDTH;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelTrailingStop.Create(m_chart_id,m_name+"LabelTrailingStop",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelTrailingStop.Text("Trailing Stop Start"))
      return(false);
   if(!Add(m_labelTrailingStop))
      return(false);
   m_labelTrailingStop.Color(clrWhite);
 //  m_labelTrailingStop.Font("Arial Black");
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Edit Trailing Stop" field                            |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateSpinEditTrailingStop(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+INDENT_IN_RECTANGLE_LEFT+CONTROLS_GAP_X+COMBO_WIDTH;
   int y1=INDENT_TOP+3*LABEL_HEIGHT+8*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*COMBO_HEIGHT+7*INDENT_IN_RECTANGLE_TOP
          +BUTTON_BUY_SELL_HEIGHT+RADIO_HEIGHT;
   int x2=x1+SPIN_EDIT_WIDTH;
   int y2=y1+SPIN_EDIT_HEIGHT;
//--- create
   if(!m_spinEditTrailingStop.Create(m_chart_id,m_name+"spinEditTrailingStop",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_spinEditTrailingStop))
      return(false);
   m_spinEditTrailingStop.MaxValue(100);
   m_spinEditTrailingStop.setDigits(1);
   m_spinEditTrailingStop.Value(-1);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Trailing Stop Distance" label                  |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelTrailingStopDistance(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+4*LABEL_HEIGHT+9*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*COMBO_HEIGHT+7*INDENT_IN_RECTANGLE_TOP
          +BUTTON_BUY_SELL_HEIGHT+RADIO_HEIGHT;
   int x2=x1+LABEL_WIDTH;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelTrailingStopDistance.Create(m_chart_id,m_name+"LabelTrailingStopDistance",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelTrailingStopDistance.Text("Trailing Stop Distance"))
      return(false);
   if(!Add(m_labelTrailingStopDistance))
      return(false);
   m_labelTrailingStopDistance.Color(clrWhite);
 //  m_labelTrailingStop.Font("Arial Black");
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Edit Trailing Stop Distance" field                   |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateSpinEditTrailingStopDistance(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+INDENT_IN_RECTANGLE_LEFT+CONTROLS_GAP_X+COMBO_WIDTH;
   int y1=INDENT_TOP+4*LABEL_HEIGHT+9*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*COMBO_HEIGHT+7*INDENT_IN_RECTANGLE_TOP
          +BUTTON_BUY_SELL_HEIGHT+RADIO_HEIGHT;
   int x2=x1+SPIN_EDIT_WIDTH;
   int y2=y1+SPIN_EDIT_HEIGHT;
//--- create
   if(!m_spinEditTrailingStopDistance.Create(m_chart_id,m_name+"spinEditTrailingStopDistance",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_spinEditTrailingStopDistance))
      return(false);
   m_spinEditTrailingStopDistance.MaxValue(100);
   m_spinEditTrailingStopDistance.setDigits(1);
   m_spinEditTrailingStopDistance.Value(-1);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Button More Actions" button                          |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateButtonMoreActions(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+LABEL_TRADE_WIDTH+2*LABELS_TRADE_GAP_X+LABEL_MODIFY_TRADE_WIDTH;
   int y1=INDENT_TOP;
   int x2=x1+BUTTON_ACTIONS_WIDTH;               
   int y2=y1+BUTTON_ACTIONS_HEIGHT;
//--- create
   if(!m_buttonMoreActions.Create(m_chart_id,m_name+"ButtonMoreActions",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_buttonMoreActions.Text("More Actions..."))
      return(false);
   if(!Add(m_buttonMoreActions))
      return(false);
   m_buttonMoreActions.ColorBackground(COLOR_COMBOBOX);
   m_buttonMoreActions.Locking(true);
   m_buttonMoreActions.Color(clrWhite);
   m_buttonMoreActions.ColorBorder(COLOR_COMBOBOX);
  // m_buttonMoreActions.Font("Arial Black");
  // m_buttonMoreActions.FontSize(BUTTON_TEXT_FONTSIZE);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Pending Order" label                           |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelPendingOrder(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP;
   int x2=x1+LABEL_WIDTH;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelPendingOrder.Create(m_chart_id,m_name+"LabelPendingOrder",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelPendingOrder.Text("Pending Order"))
      return(false);
   if(!Add(m_labelPendingOrder))
      return(false);
   m_labelPendingOrder.Color(clrWhite);
 //  m_labelPendingOrder.Font("Arial Black");
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Pending" rectangle label                             |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateRectanglePending(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+2*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT;
   int x2=x1+COMBO_WIDTH+2*INDENT_IN_RECTANGLE_LEFT;
   int y2=y1+3*COMBO_HEIGHT+2*INDENT_IN_RECTANGLE_TOP+2*CONTROLS_GAP_Y;
//--- create
   if(!m_rectanglePending.Create(m_chart_id,m_name+"rectanglePending",m_subwin,x1,y1,x2,y2))
      return(false);

   if(!Add(m_rectanglePending))
      return(false);
   m_rectanglePending.ColorBorder(COLOR_OFF);
   m_rectanglePending.ColorBackground(MAIN_COLOR);
//--- succeed

   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Combo box Distance" label                            |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateComboboxDistance(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+2*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+INDENT_IN_RECTANGLE_TOP;
   int x2=x1+COMBO_WIDTH;
   int y2=y1+COMBO_HEIGHT;
//--- create
   if(!m_comboboxDistance.Create(m_chart_id,m_name+"ComboboxDistance",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_comboboxDistance))
      return(false);
//--- fill out with strings
   if(!m_comboboxDistance.AddItem("Distance in pips",0))
      return(false);
   if(!m_comboboxDistance.AddItem("Exact entry price",1))
      return(false);
   if(!m_comboboxDistance.Select(0))
      return(false);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Spin Edit Distance" field                            |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateSpinEditDistance(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+3*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+INDENT_IN_RECTANGLE_TOP+COMBO_HEIGHT;
   int x2=x1+SPIN_EDIT_WIDTH;
   int y2=y1+SPIN_EDIT_HEIGHT;
//--- create
   if(!m_spinEditDistance.Create(m_chart_id,m_name+"spinEditDistance",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_spinEditDistance))
      return(false);
   m_spinEditDistance.MaxValue(100);
   m_spinEditDistance.setDigits(1);
   m_spinEditDistance.Value(pendDist);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Combo box Pending Type" label                        |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateComboboxPendingType(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+4*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+INDENT_IN_RECTANGLE_TOP+COMBO_HEIGHT+SPIN_EDIT_HEIGHT;
   int x2=x1+COMBO_WIDTH;
   int y2=y1+COMBO_HEIGHT;
//--- create
   if(!m_comboboxPendingType.Create(m_chart_id,m_name+"ComboboxPendingType",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_comboboxPendingType))
      return(false);
//--- fill out with strings
   if(!m_comboboxPendingType.AddItem("BUY STOP",0))
      return(false);
   if(!m_comboboxPendingType.AddItem("SELL STOP",1))
      return(false);
   if(!m_comboboxPendingType.AddItem("BUY LIMIT",2))
      return(false);
   if(!m_comboboxPendingType.AddItem("SELL LIMIT",3))
      return(false);
   if(!m_comboboxPendingType.AddItem("BUY&SELL (Straddle)",4))
      return(false);
   if(!m_comboboxPendingType.Select(0))
      return(false);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Button Place Pending" button                         |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateButtonPlacePending(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+2*CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT+SPIN_EDIT_WIDTH;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+3*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+INDENT_IN_RECTANGLE_TOP+COMBO_HEIGHT;
   int x2=x1+SPIN_EDIT_WIDTH-8;
   int y2=y1+SPIN_EDIT_HEIGHT;
//--- create
   if(!m_buttonPlacePending.Create(m_chart_id,m_name+"ButtonPlacePending",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_buttonPlacePending.Text("Place PO"))
      return(false);
   if(!Add(m_buttonPlacePending))
      return(false);
   m_buttonPlacePending.ColorBackground(clrGreen);
   m_buttonPlacePending.ColorBorder(clrGreen);
   m_buttonPlacePending.Locking(false);
   m_buttonPlacePending.Color(clrWhite);
   m_buttonPlacePending.Font("Arial Black");
   m_buttonPlacePending.FontSize(BUTTON_TEXT_FONTSIZE);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Preview" rectangle label                             |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateRectanglePreview(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+5*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+2*INDENT_IN_RECTANGLE_TOP+2*COMBO_HEIGHT+SPIN_EDIT_HEIGHT;
   int x2=x1+COMBO_WIDTH+2*INDENT_IN_RECTANGLE_LEFT;
   int y2=y1+COMBO_HEIGHT+2*INDENT_IN_RECTANGLE_TOP+6*CONTROLS_GAP_Y+LABEL_HEIGHT+RADIO_ONOFF_HEIGHT+4*LABEL_HEIGHT;
//--- create
   if(!m_rectanglePreview.Create(m_chart_id,m_name+"rectanglePreview",m_subwin,x1,y1,x2,y2))
      return(false);

   if(!Add(m_rectanglePreview))
      return(false);
   m_rectanglePreview.ColorBorder(COLOR_OFF);
   m_rectanglePreview.ColorBackground(MAIN_COLOR);
//--- succeed

   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Label Preview" label                           |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelPreview(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+2*LABEL_HEIGHT+5*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+2*COMBO_HEIGHT+SPIN_EDIT_HEIGHT;
   int x2=x1+LABEL_WIDTH;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelPreview.Create(m_chart_id,m_name+"LabelPreview",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelPreview.Text("Preview On Chart"))
      return(false);
   if(!Add(m_labelPreview))
      return(false);
   m_labelPreview.Color(clrWhite);
 //  m_labelPreview.Font("Arial Black");
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Radio Button On" element                             |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateRadioOn(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+3*LABEL_HEIGHT+6*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+2*COMBO_HEIGHT+SPIN_EDIT_HEIGHT;
   int x2=x1+RADIO_ONOFF_WIDTH;
   int y2=y1+RADIO_ONOFF_HEIGHT;
//--- create
   if(!m_radioOn.Create(m_chart_id,m_name+"RadioOn",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_radioOn))
      return(false);
//   m_radioNormalReverse.Alignment(WND_ALIGN_WIDTH,0,0,0,0);
//--- fill out with strings
   if(!m_radioOn.Text("On"))
      return(false);
   if(!m_radioOn.State(false))
      return(false);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Radio Button Off" element                            |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateRadioOff(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+2*CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT+RADIO_ONOFF_WIDTH;
   int y1=INDENT_TOP+3*LABEL_HEIGHT+6*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+2*COMBO_HEIGHT+SPIN_EDIT_HEIGHT;
   int x2=x1+RADIO_ONOFF_WIDTH;
   int y2=y1+RADIO_ONOFF_HEIGHT;
//--- create
   if(!m_radioOff.Create(m_chart_id,m_name+"RadioOff",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_radioOff))
      return(false);
//   m_radioNormalReverse.Alignment(WND_ALIGN_WIDTH,0,0,0,0);
//--- fill out with strings
   if(!m_radioOff.Text("Off"))
      return(false);
   if(!m_radioOff.State(true))
      return(false);
//--- succeed
   return(true);
  }

//+------------------------------------------------------------------+
//| Create the "Combo box Orders Type" label                         |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateComboboxOrdersType(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+3*LABEL_HEIGHT+7*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+2*COMBO_HEIGHT+SPIN_EDIT_HEIGHT+
          RADIO_ONOFF_HEIGHT;
   int x2=x1+COMBO_WIDTH;
   int y2=y1+COMBO_HEIGHT;
//--- create
   if(!m_comboboxOrdersType.Create(m_chart_id,m_name+"ComboboxOrdersType",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_comboboxOrdersType))
      return(false);
//--- fill out with strings
   if(!m_comboboxOrdersType.AddItem("Pending Order",0))
      return(false);
   if(!m_comboboxOrdersType.AddItem("Buy",1))
      return(false);
   if(!m_comboboxOrdersType.AddItem("Sell",1))
      return(false);
   if(!m_comboboxOrdersType.Select(0))
      return(false);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Label Loss On SL" label                        |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelLossOnSL(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+3*LABEL_HEIGHT+8*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+3*COMBO_HEIGHT+SPIN_EDIT_HEIGHT+
          RADIO_ONOFF_HEIGHT;
   int x2=x1+LABEL_WIDTH2;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelLossOnSL.Create(m_chart_id,m_name+"LabelLossOnSL",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelLossOnSL.Text("Loss On SL"))
      return(false);
   if(!Add(m_labelLossOnSL))
      return(false);
   m_labelLossOnSL.Color(clrWhite);
   m_labelLossOnSL.FontSize(9);
//   m_labelLossOnSL.Font("Arial Black");
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Label Loss On SL Value" label                  |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelLossOnSLValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+2*CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT+LABEL_WIDTH2;
   int y1=INDENT_TOP+3*LABEL_HEIGHT+8*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+3*COMBO_HEIGHT+SPIN_EDIT_HEIGHT+
          RADIO_ONOFF_HEIGHT;
   int x2=x1+LABEL_WIDTH2;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelLossOnSLValue.Create(m_chart_id,m_name+"LabelLossOnSLValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelLossOnSLValue.Text("$20.00 (0.37%)"))
      return(false);
   if(!Add(m_labelLossOnSLValue))
      return(false);
   m_labelLossOnSLValue.Color(clrRed);
   m_labelLossOnSLValue.FontSize(9);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Label Profit On TP" label                      |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelProfitOnTP(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+4*LABEL_HEIGHT+9*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+3*COMBO_HEIGHT+SPIN_EDIT_HEIGHT+
          RADIO_ONOFF_HEIGHT;
   int x2=x1+LABEL_WIDTH2;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelProfitOnTP.Create(m_chart_id,m_name+"LabelProfitOnTP",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelProfitOnTP.Text("Prof on TP"))
      return(false);
   if(!Add(m_labelProfitOnTP))
      return(false);
   m_labelProfitOnTP.Color(clrWhite);
   m_labelProfitOnTP.FontSize(9);
 //  m_labelProfitOnTP.Font("Arial Black");
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Label Profit On TP Value" label                |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelProfitOnTPValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+2*CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT+LABEL_WIDTH2;
   int y1=INDENT_TOP+4*LABEL_HEIGHT+9*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+3*COMBO_HEIGHT+SPIN_EDIT_HEIGHT+
          RADIO_ONOFF_HEIGHT;
   int x2=x1+LABEL_WIDTH2;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelProfitOnTPValue.Create(m_chart_id,m_name+"LabelProfitOnTPValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelProfitOnTPValue.Text("$19.00 (0.35%)"))
      return(false);
   if(!Add(m_labelProfitOnTPValue))
      return(false);
   m_labelProfitOnTPValue.Color(clrGreen);
   m_labelProfitOnTPValue.FontSize(9);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Label Lot Size1" label                         |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelLotSize1(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+5*LABEL_HEIGHT+10*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+3*COMBO_HEIGHT+SPIN_EDIT_HEIGHT+
          RADIO_ONOFF_HEIGHT;
   int x2=x1+LABEL_WIDTH2;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelLotSize1.Create(m_chart_id,m_name+"LabelLotSize1",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelLotSize1.Text("Lot Size"))
      return(false);
   if(!Add(m_labelLotSize1))
      return(false);
   m_labelLotSize1.Color(clrWhite);
   m_labelLotSize1.FontSize(9);
 //  m_labelLotSize1.Font("Arial Black");
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Label Lot Size1 Value" label                   |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelLotSize1Value(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+2*CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT+LABEL_WIDTH2;
   int y1=INDENT_TOP+5*LABEL_HEIGHT+10*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+3*COMBO_HEIGHT+SPIN_EDIT_HEIGHT+
          RADIO_ONOFF_HEIGHT;
   int x2=x1+LABEL_WIDTH2;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelLotSize1Value.Create(m_chart_id,m_name+"LabelLotSize1Value",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelLotSize1Value.Text("0.10"))
      return(false);
   if(!Add(m_labelLotSize1Value))
      return(false);
   m_labelLotSize1Value.Color(clrWhite);
   m_labelLotSize1Value.FontSize(9);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Label Margin" label                            |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelMargin(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT;
   int y1=INDENT_TOP+6*LABEL_HEIGHT+11*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+3*COMBO_HEIGHT+SPIN_EDIT_HEIGHT+
          RADIO_ONOFF_HEIGHT;
   int x2=x1+LABEL_WIDTH2;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelMargin.Create(m_chart_id,m_name+"LabelMargin",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelMargin.Text("Margin"))
      return(false);
   if(!Add(m_labelMargin))
      return(false);
   m_labelMargin.Color(clrWhite);
   m_labelMargin.FontSize(9);
//   m_labelMargin.Font("Arial Black");
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Label Margin Value" label                      |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelMarginValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+2*CONTROLS_GAP_X+RECTANGLE_LOT_SIZE_WIDTH+INDENT_IN_RECTANGLE_LEFT+LABEL_WIDTH2;
   int y1=INDENT_TOP+6*LABEL_HEIGHT+11*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+3*INDENT_IN_RECTANGLE_TOP+3*COMBO_HEIGHT+SPIN_EDIT_HEIGHT+
          RADIO_ONOFF_HEIGHT;
   int x2=x1+LABEL_WIDTH2;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelMarginValue.Create(m_chart_id,m_name+"LabelMarginValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelMarginValue.Text("$22.15"))
      return(false);
   if(!Add(m_labelMarginValue))
      return(false);
   m_labelMarginValue.Color(clrBlue);
   m_labelMarginValue.FontSize(9);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Rectangle" element                                   |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateRect(void)
  {
//--- coordinates
   int x1=Right();
   int y1=Top()+CONTROLS_DIALOG_CAPTION_HEIGHT;
   int x2=x1+RECT_WIDTH;
   int y2=y1+RECT_HEIGHT;
//--- create
   if(!m_rectangle.Create(m_chart_id,m_name+"Rectangle",m_subwin,x1,y1,x2,y2))
      return(false);
   m_rectangle.ColorBackground(MAIN_COLOR);
   m_rectangle.ColorBorder(MAIN_COLOR);
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Button Close All Trades" button                      |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateButtonCloseAllTrades(void)
  {
//--- coordinates
   int x1=Right()+RECT_INDENT_LEFT;
   int y1=Top()+CONTROLS_DIALOG_CAPTION_HEIGHT+RECT_INDENT_TOP;
   int x2=x1+BUTTON_MORE_ACTIONS_WIDTH;
   int y2=y1+BUTTON_MORE_ACTIONS_HEIGHT;
//--- create
   if(!m_buttonCloseAllTrades.Create(m_chart_id,"RM ButtonCloseAllTrades",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_buttonCloseAllTrades.Text("Close all trades now (" + IntegerToString(tradesQuantity) + ")"))
      return(false);
   m_buttonCloseAllTrades.ColorBackground(clrOrangeRed);
   m_buttonCloseAllTrades.ColorBorder(MAIN_COLOR);
   m_buttonCloseAllTrades.Locking(false);
   m_buttonCloseAllTrades.Color(clrWhite);
   m_buttonCloseAllTrades.FontSize(BUTTON_MORE_ACTIONS_FONTSIZE);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Button Delete All Pending" button                    |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateButtonDeleteAllPending(void)
  {
//--- coordinates
   int x1=Right()+RECT_INDENT_LEFT;
   int y1=Top()+CONTROLS_DIALOG_CAPTION_HEIGHT+RECT_INDENT_TOP+CONTROLS_GAP_Y_BUTTONS+BUTTON_MORE_ACTIONS_HEIGHT;
   int x2=x1+BUTTON_MORE_ACTIONS_WIDTH;
   int y2=y1+BUTTON_MORE_ACTIONS_HEIGHT;
//--- create
   if(!m_buttonDeleteAllPending.Create(m_chart_id,"RM DeleteAllPending",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_buttonDeleteAllPending.Text("Delete all pending orders (" + IntegerToString(pendingQuantity) + ")"))
      return(false);
   m_buttonDeleteAllPending.ColorBackground(clrOrangeRed);
   m_buttonDeleteAllPending.ColorBorder(MAIN_COLOR);
   m_buttonDeleteAllPending.Locking(false);
   m_buttonDeleteAllPending.Color(clrWhite);
   m_buttonDeleteAllPending.FontSize(BUTTON_MORE_ACTIONS_FONTSIZE);
   
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Button Close 50% Volume" button                      |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateButtonClose50Volume(void)
  {
//--- coordinates
   int x1=Right()+RECT_INDENT_LEFT;
   int y1=Top()+CONTROLS_DIALOG_CAPTION_HEIGHT+RECT_INDENT_TOP+2*CONTROLS_GAP_Y_BUTTONS+2*BUTTON_MORE_ACTIONS_HEIGHT;
   int x2=x1+BUTTON_MORE_ACTIONS_WIDTH;
   int y2=y1+BUTTON_MORE_ACTIONS_HEIGHT;
//--- create
   if(!m_buttonClose50Volume.Create(m_chart_id,"RM ButtonClose50Volume",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_buttonClose50Volume.Text("Close 50% of the volume (" + IntegerToString(tradesQuantity) + ")"))
      return(false);
   m_buttonClose50Volume.ColorBackground(clrOrangeRed);
   m_buttonClose50Volume.ColorBorder(MAIN_COLOR);
   m_buttonClose50Volume.Locking(false);
   m_buttonClose50Volume.Color(clrWhite);
   m_buttonClose50Volume.FontSize(BUTTON_MORE_ACTIONS_FONTSIZE);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Button Close All Loss" button                        |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateButtonCloseAllLoss(void)
  {
//--- coordinates
   int x1=Right()+RECT_INDENT_LEFT;
   int y1=Top()+CONTROLS_DIALOG_CAPTION_HEIGHT+RECT_INDENT_TOP+3*CONTROLS_GAP_Y_BUTTONS+3*BUTTON_MORE_ACTIONS_HEIGHT;
   int x2=x1+BUTTON_MORE_ACTIONS_WIDTH;
   int y2=y1+BUTTON_MORE_ACTIONS_HEIGHT;
//--- create
   if(!m_buttonCloseAllLoss.Create(m_chart_id,"RM ButtonCloseAllLoss",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_buttonCloseAllLoss.Text("Close all trades flt in loss (" + IntegerToString(tradesInLoss) + ")"))
      return(false);
   m_buttonCloseAllLoss.ColorBackground(clrOrangeRed);
   m_buttonCloseAllLoss.ColorBorder(MAIN_COLOR);
   m_buttonCloseAllLoss.Locking(false);
   m_buttonCloseAllLoss.Color(clrWhite);
   m_buttonCloseAllLoss.FontSize(BUTTON_MORE_ACTIONS_FONTSIZE);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Button Close All Profit" button                      |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateButtonCloseAllProfit(void)
  {
//--- coordinates
   int x1=Right()+RECT_INDENT_LEFT;
   int y1=Top()+CONTROLS_DIALOG_CAPTION_HEIGHT+RECT_INDENT_TOP+4*CONTROLS_GAP_Y_BUTTONS+4*BUTTON_MORE_ACTIONS_HEIGHT;
   int x2=x1+BUTTON_MORE_ACTIONS_WIDTH;
   int y2=y1+BUTTON_MORE_ACTIONS_HEIGHT;
//--- create
   if(!m_buttonCloseAllProfit.Create(m_chart_id,"RM ButtonCloseAllProfit",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_buttonCloseAllProfit.Text("Close all trades flt in profit (" + IntegerToString(tradesInProfit) + ")"))
      return(false);
   m_buttonCloseAllProfit.ColorBackground(clrOrangeRed);
   m_buttonCloseAllProfit.ColorBorder(MAIN_COLOR);
   m_buttonCloseAllProfit.Locking(false);
   m_buttonCloseAllProfit.Color(clrWhite);
   m_buttonCloseAllProfit.FontSize(BUTTON_MORE_ACTIONS_FONTSIZE);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Button Close All Buy" button                         |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateButtonCloseAllBuy(void)
  {
//--- coordinates
   int x1=Right()+RECT_INDENT_LEFT;
   int y1=Top()+CONTROLS_DIALOG_CAPTION_HEIGHT+RECT_INDENT_TOP+5*CONTROLS_GAP_Y_BUTTONS+5*BUTTON_MORE_ACTIONS_HEIGHT;
   int x2=x1+BUTTON_MORE_ACTIONS_WIDTH;
   int y2=y1+BUTTON_MORE_ACTIONS_HEIGHT;
//--- create
   if(!m_buttonCloseAllBuy.Create(m_chart_id,"RM ButtonCloseAllBuy",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_buttonCloseAllBuy.Text("Close all BUY trades now (" + IntegerToString(tradesBuy) + ")"))
      return(false);
   m_buttonCloseAllBuy.ColorBackground(clrOrangeRed);
   m_buttonCloseAllBuy.ColorBorder(MAIN_COLOR);
   m_buttonCloseAllBuy.Locking(false);
   m_buttonCloseAllBuy.Color(clrWhite);
   m_buttonCloseAllBuy.FontSize(BUTTON_MORE_ACTIONS_FONTSIZE);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Button Close All Sell" button                        |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateButtonCloseAllSell(void)
  {
//--- coordinates
   int x1=Right()+RECT_INDENT_LEFT;
   int y1=Top()+CONTROLS_DIALOG_CAPTION_HEIGHT+RECT_INDENT_TOP+6*CONTROLS_GAP_Y_BUTTONS+6*BUTTON_MORE_ACTIONS_HEIGHT;
   int x2=x1+BUTTON_MORE_ACTIONS_WIDTH;
   int y2=y1+BUTTON_MORE_ACTIONS_HEIGHT;
//--- create
   if(!m_buttonCloseAllSell.Create(m_chart_id,"RM ButtonCloseAllSell",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_buttonCloseAllSell.Text("Close all SELL trades now (" + IntegerToString(tradesSell) + ")"))
      return(false);
   m_buttonCloseAllSell.ColorBackground(clrOrangeRed);
   m_buttonCloseAllSell.ColorBorder(MAIN_COLOR);
   m_buttonCloseAllSell.Locking(false);
   m_buttonCloseAllSell.Color(clrWhite);
   m_buttonCloseAllSell.FontSize(BUTTON_MORE_ACTIONS_FONTSIZE);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Order Details" rectangle label                       |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateRectangleOrderDetails(void)
  {
//--- coordinates
   int x1=INDENT_LEFT;
   int y1=INDENT_TOP+1.5*LABEL_HEIGHT+2*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT;
   int x2=x1+EDIT_DATETIME_WIDTH+2*RECT_INDENT_LEFT;
   int y2=y1+COMBO_HEIGHT+2*INDENT_IN_RECTANGLE_TOP+2*LABEL_HEIGHT+13*CONTROLS_GAP_Y+11*LABEL_HEIGHT3;
//--- create
   if(!m_rectangleOrderDetails.Create(m_chart_id,m_name+"rectangleOrderDetails",m_subwin,x1,y1,x2,y2))
      return(false);

   if(!Add(m_rectangleOrderDetails))
      return(false);
   m_rectangleOrderDetails.ColorBorder(COLOR_OFF);
   m_rectangleOrderDetails.ColorBackground(MAIN_COLOR);
//--- succeed

   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Select Order" label                            |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelSelectOrder(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT;
   int y1=INDENT_TOP+1.5*LABEL_HEIGHT+2*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP;
   int x2=x1+LABEL_WIDTH;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelSelectOrder.Create(m_chart_id,m_name+"LabelSelectOrder",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelSelectOrder.Text("Select Order"))
      return(false);
   if(!Add(m_labelSelectOrder))
      return(false);
   m_labelSelectOrder.Color(COLOR_ON);
 //  m_labelSelectOrder.Font("Arial Black");
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Combo box Select Order" label                            |
//+------------------------------------------------------------------+
bool CPanelDialog:: CreateComboboxSelectOrder(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+3*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP;
   int x2=x1+EDIT_DATETIME_WIDTH;
   int y2=y1+COMBO_HEIGHT;
//--- create
   if(!m_comboboxSelectOrder.Create(m_chart_id,m_name+"ComboboxSelectOrder",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_comboboxSelectOrder))
      return(false);
//--- fill out with strings
   if(!m_comboboxSelectOrder.AddItem("NA",0))
      return(false);
 /*  if(!m_comboboxLotSizeDropdown.AddItem("Risk in USD ($)",1))
      return(false);
   if(!m_comboboxLotSizeDropdown.AddItem("Lot Size (Fixed)",2))
      return(false);*/
   if(!m_comboboxSelectOrder.Select(0))
      return(false);
   // Selected: m_comboboxLotSizeDropdown.Select());
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Order Details" label                           |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelOrderDetails(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+4*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT;
   int x2=x1+LABEL_WIDTH;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelOrderDetails.Create(m_chart_id,m_name+"LabelOrderDetails",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelOrderDetails.Text("Order Details"))
      return(false);
   if(!Add(m_labelOrderDetails))
      return(false);
   m_labelOrderDetails.Color(COLOR_ON);
 //  m_labelOrderDetails.Font("Arial Black");
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Symbol" label                                  |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelSymbol(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+5*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelSymbol.Create(m_chart_id,m_name+"LabelSymbol",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelSymbol.Text("Symbol"))
      return(false);
   if(!Add(m_labelSymbol))
      return(false);
   m_labelSymbol.Color(COLOR_ON);   
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Symbol Value" label                            |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelSymbolValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT+LABEL_WIDTH3;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+5*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelSymbolValue.Create(m_chart_id,m_name+"LabelSymbolValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelSymbolValue.Text("EURUSD"))
      return(false);
   if(!Add(m_labelSymbolValue))
      return(false);
   m_labelSymbolValue.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Action" label                                  |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelAction(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+6*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+1*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelAction.Create(m_chart_id,m_name+"LabelAction",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelAction.Text("Action"))
      return(false);
   if(!Add(m_labelAction))
      return(false);
   m_labelAction.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Action Value" label                            |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelActionValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT+LABEL_WIDTH3;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+6*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+1*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelActionValue.Create(m_chart_id,m_name+"LabelActionValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelActionValue.Text("BUY"))
      return(false);
   if(!Add(m_labelActionValue))
      return(false);
   m_labelActionValue.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Size" label                                    |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelSize(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+7*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+2*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelSize.Create(m_chart_id,m_name+"LabelSize",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelSize.Text("Size"))
      return(false);
   if(!Add(m_labelSize))
      return(false);
   m_labelSize.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Size Value" label                              |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelSizeValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT+LABEL_WIDTH3;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+7*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+2*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelSizeValue.Create(m_chart_id,m_name+"LabelSizeValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelSizeValue.Text("0.10"))
      return(false);
   if(!Add(m_labelSizeValue))
      return(false);
   m_labelSizeValue.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Open Price" label                              |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelOpenPrice(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+8*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+3*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelOpenPrice.Create(m_chart_id,m_name+"LabelOpenPrice",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelOpenPrice.Text("Open Price"))
      return(false);
   if(!Add(m_labelOpenPrice))
      return(false);
   m_labelOpenPrice.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Open Price Value" label                        |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelOpenPriceValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT+LABEL_WIDTH3;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+8*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+3*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelOpenPriceValue.Create(m_chart_id,m_name+"LabelOpenPriceValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelOpenPriceValue.Text("1.14220"))
      return(false);
   if(!Add(m_labelOpenPriceValue))
      return(false);
   m_labelOpenPriceValue.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Take Profit" label                             |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelTakeProfit(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+9*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+4*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelTakeProfit.Create(m_chart_id,m_name+"LabelTakeProfit",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelTakeProfit.Text("Take Profit"))
      return(false);
   if(!Add(m_labelTakeProfit))
      return(false);
   m_labelTakeProfit.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Take Profit Value" label                       |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelTakeProfitValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT+LABEL_WIDTH3;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+9*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+4*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelTakeProfitValue.Create(m_chart_id,m_name+"LabelTakeProfitValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelTakeProfitValue.Text("0.00000"))
      return(false);
   if(!Add(m_labelTakeProfitValue))
      return(false);
   m_labelTakeProfitValue.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Stop Loss" label                               |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelStopLoss(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+10*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+5*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelStopLoss.Create(m_chart_id,m_name+"LabelStopLoss",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelStopLoss.Text("Stop Loss"))
      return(false);
   if(!Add(m_labelStopLoss))
      return(false);
   m_labelStopLoss.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Stop Loss Value" label                         |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelStopLossValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT+LABEL_WIDTH3;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+10*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+5*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelStopLossValue.Create(m_chart_id,m_name+"LabelStopLossValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelStopLossValue.Text("1.13110"))
      return(false);
   if(!Add(m_labelStopLossValue))
      return(false);
   m_labelStopLossValue.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Comment" label                                 |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelComment(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+11*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+6*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelComment.Create(m_chart_id,m_name+"LabelComment",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelComment.Text("Comment"))
      return(false);
   if(!Add(m_labelComment))
      return(false);
   m_labelComment.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Comment Value" label                           |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelCommentValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT+LABEL_WIDTH3;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+11*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+6*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelCommentValue.Create(m_chart_id,m_name+"LabelCommentValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelCommentValue.Text("kuku"))
      return(false);
   if(!Add(m_labelCommentValue))
      return(false);
   m_labelCommentValue.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Trail Stop" label                              |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelTrailStop(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+12*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+7*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelTrailStop.Create(m_chart_id,m_name+"LabelTrailStop",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelTrailStop.Text("TS Start"))
      return(false);
   if(!Add(m_labelTrailStop))
      return(false);
   m_labelTrailStop.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Trail Stop Value" label                              |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelTrailStopValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT+LABEL_WIDTH3;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+12*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+7*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelTrailStopValue.Create(m_chart_id,m_name+"LabelTrailStopValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelTrailStopValue.Text("none"))
      return(false);
   if(!Add(m_labelTrailStopValue))
      return(false);
   m_labelTrailStopValue.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Trail Stop Distance" label                     |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelTrailStopDistance(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+13*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+8*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelTrailStopDistance.Create(m_chart_id,m_name+"LabelTrailStopDistance",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelTrailStopDistance.Text("TS Distance"))
      return(false);
   if(!Add(m_labelTrailStopDistance))
      return(false);
   m_labelTrailStopDistance.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Trail Stop Value" label                              |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelTrailStopDistanceValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT+LABEL_WIDTH3;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+13*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+8*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelTrailStopDistanceValue.Create(m_chart_id,m_name+"LabelTrailStopDistanceValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelTrailStopDistanceValue.Text("none"))
      return(false);
   if(!Add(m_labelTrailStopDistanceValue))
      return(false);
   m_labelTrailStopDistanceValue.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Break Even" label                              |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelBreakEven(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+14*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+9*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelBreakEven.Create(m_chart_id,m_name+"LabelBreakEven",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelBreakEven.Text("Break Even"))
      return(false);
   if(!Add(m_labelBreakEven))
      return(false);
   m_labelBreakEven.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Break Even Value" label                        |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelBreakEvenValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT+LABEL_WIDTH3;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+14*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+9*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelBreakEvenValue.Create(m_chart_id,m_name+"LabelBreakEvenValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelBreakEvenValue.Text("2.0 pips"))
      return(false);
   if(!Add(m_labelBreakEvenValue))
      return(false);
   m_labelBreakEvenValue.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Order Expires" label                           |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelOrderExpires(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+15*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+10*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelOrderExpires.Create(m_chart_id,m_name+"LabelOrderExpires",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelOrderExpires.Text("Order Expires"))
      return(false);
   if(!Add(m_labelOrderExpires))
      return(false);
   m_labelOrderExpires.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Order Expires Value" label                     |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelOrderExpiresValue(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+RECT_INDENT_LEFT+LABEL_WIDTH3;
   int y1=INDENT_TOP+3.5*LABEL_HEIGHT+15*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT+10*LABEL_HEIGHT3;
   int x2=x1+LABEL_WIDTH3;
   int y2=y1+LABEL_HEIGHT3;
//--- create
   if(!m_labelOrderExpiresValue.Create(m_chart_id,m_name+"LabelOrderExpiresValue",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelOrderExpiresValue.Text("NA"))
      return(false);
   if(!Add(m_labelOrderExpiresValue))
      return(false);
   m_labelOrderExpiresValue.Color(COLOR_ON);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Modify Order" rectangle label                        |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateRectangleModifyOrder(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+2*RECT_INDENT_LEFT+CONTROLS_GAP_X+EDIT_DATETIME_WIDTH;
   int y1=INDENT_TOP+1.5*LABEL_HEIGHT+2*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT;
   int x2=x1+COMBO_WIDTH1+SPIN_EDIT_WIDTH+CONTROLS_GAP_X+2*RECT_INDENT_LEFT;
   int y2=y1+COMBO_HEIGHT+2*INDENT_IN_RECTANGLE_TOP+2*LABEL_HEIGHT+13*CONTROLS_GAP_Y+11*LABEL_HEIGHT3;
//--- create
   if(!m_rectangleModifyOrder.Create(m_chart_id,m_name+"rectangleModifyOrder",m_subwin,x1,y1,x2,y2))
      return(false);

   if(!Add(m_rectangleModifyOrder))
      return(false);
   m_rectangleModifyOrder.ColorBorder(COLOR_OFF);
   m_rectangleModifyOrder.ColorBackground(MAIN_COLOR);
//--- succeed

   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Modify Order" label                            |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelModifyOrder(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+CONTROLS_GAP_X+EDIT_DATETIME_WIDTH;
   int y1=INDENT_TOP+1.5*LABEL_HEIGHT+2*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP;
   int x2=x1+LABEL_WIDTH;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelModifyOrder.Create(m_chart_id,m_name+"LabelModifyOrder",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelModifyOrder.Text("Modify Order"))
      return(false);
   if(!Add(m_labelModifyOrder))
      return(false);
   m_labelModifyOrder.Color(COLOR_ON);
 //  m_labelModifyOrder.Font("Arial Black");
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Combo box Stop Loss" label                           |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateComboboxSL(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+CONTROLS_GAP_X+EDIT_DATETIME_WIDTH;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+3*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP;
   int x2=x1+COMBO_WIDTH1;
   int y2=y1+COMBO_HEIGHT;
//--- create
   if(!m_comboboxSL.Create(m_chart_id,m_name+"ComboboxSL",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_comboboxSL))
      return(false);
//--- fill out with strings
   if(!m_comboboxSL.AddItem("Stop Loss in pips",0))
      return(false);
   if(!m_comboboxSL.AddItem("Stop Loss at price",1))
      return(false);
   if(!m_comboboxSL.Select(0))
      return(false);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Spin Edit SL" field                                  |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateSpinEditSL(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+2*CONTROLS_GAP_X+EDIT_DATETIME_WIDTH+COMBO_WIDTH1;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+3*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP;
   int x2=x1+SPIN_EDIT_WIDTH;
   int y2=y1+SPIN_EDIT_HEIGHT;
//--- create
   if(!m_spinEditSL.Create(m_chart_id,m_name+"spinEditSL",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_spinEditSL))
      return(false);
   m_spinEditSL.MaxValue(10000);
   m_spinEditSL.setDigits(1);
   m_spinEditSL.Value(0);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Combo box Take Profit" label                         |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateComboboxTP(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+CONTROLS_GAP_X+EDIT_DATETIME_WIDTH;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+4*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT;
   int x2=x1+COMBO_WIDTH1;
   int y2=y1+COMBO_HEIGHT;
//--- create
   if(!m_comboboxTP.Create(m_chart_id,m_name+"ComboboxTP",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_comboboxTP))
      return(false);
//--- fill out with strings
   if(!m_comboboxTP.AddItem("Take Profit in pips",0))
      return(false);
   if(!m_comboboxTP.AddItem("Take Profit at price",1))
      return(false);
   if(!m_comboboxTP.AddItem("Take Profit at seconds",2))
      return(false);
   if(!m_comboboxTP.Select(0))
      return(false);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Spin Edit TP" field                                  |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateSpinEditTP(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+2*CONTROLS_GAP_X+EDIT_DATETIME_WIDTH+COMBO_WIDTH1;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+4*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+COMBO_HEIGHT;
   int x2=x1+SPIN_EDIT_WIDTH;
   int y2=y1+SPIN_EDIT_HEIGHT;
//--- create
   if(!m_spinEditTP.Create(m_chart_id,m_name+"spinEditTP",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_spinEditTP))
      return(false);
   m_spinEditTP.MaxValue(10000);
   m_spinEditTP.setDigits(1);
   m_spinEditTP.Value(0);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Smart Breakeven2" label                         |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelBreakeven2(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+CONTROLS_GAP_X+EDIT_DATETIME_WIDTH;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+5*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+2*COMBO_HEIGHT;
   int x2=x1+LABEL_WIDTH;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelBreakeven2.Create(m_chart_id,m_name+"LabelBreakeven2",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelBreakeven2.Text("Smart Breakeven"))
      return(false);
   if(!Add(m_labelBreakeven2))
      return(false);
   m_labelBreakeven2.Color(COLOR_ON);
 //  m_labelBreakeven2.Font("Arial Black");

//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Edit Breakeven2" field                                |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateSpinEditBreakeven2(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+2*CONTROLS_GAP_X+EDIT_DATETIME_WIDTH+COMBO_WIDTH1;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+5*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+2*COMBO_HEIGHT;
   int x2=x1+SPIN_EDIT_WIDTH;
   int y2=y1+SPIN_EDIT_HEIGHT;
//--- create
   if(!m_spinEditBreakeven2.Create(m_chart_id,m_name+"spinEditBreakeven2",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_spinEditBreakeven2))
      return(false);
   m_spinEditBreakeven2.MaxValue(100);
   m_spinEditBreakeven2.setDigits(1);
   m_spinEditBreakeven2.Value(0);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Trailing Stop2" label                           |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelTrailingStop2(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+CONTROLS_GAP_X+EDIT_DATETIME_WIDTH;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+6*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+3*COMBO_HEIGHT;
   int x2=x1+LABEL_WIDTH;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelTrailingStop2.Create(m_chart_id,m_name+"LabelTrailingStop2",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelTrailingStop2.Text("Trailing Stop Start"))
      return(false);
   if(!Add(m_labelTrailingStop2))
      return(false);
   m_labelTrailingStop2.Color(COLOR_ON);
 //  m_labelTrailingStop2.Font("Arial Black");
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Edit Trailing Stop2" field                            |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateSpinEditTrailingStop2(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+2*CONTROLS_GAP_X+EDIT_DATETIME_WIDTH+COMBO_WIDTH1;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+6*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+3*COMBO_HEIGHT;
   int x2=x1+SPIN_EDIT_WIDTH;
   int y2=y1+SPIN_EDIT_HEIGHT;
//--- create
   if(!m_spinEditTrailingStop2.Create(m_chart_id,m_name+"spinEditTrailingStop2",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_spinEditTrailingStop2))
      return(false);
   m_spinEditTrailingStop2.MaxValue(100);
   m_spinEditTrailingStop2.setDigits(1);
   m_spinEditTrailingStop2.Value(0);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Trailing Stop Distance2" label                 |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelTrailingStopDistance2(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+CONTROLS_GAP_X+EDIT_DATETIME_WIDTH;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+7*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+4*COMBO_HEIGHT;
   int x2=x1+LABEL_WIDTH;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelTrailingStopDistance2.Create(m_chart_id,m_name+"LabelTrailingStopDistance2",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelTrailingStopDistance2.Text("Trail. Stop Distance"))
      return(false);
   if(!Add(m_labelTrailingStopDistance2))
      return(false);
   m_labelTrailingStopDistance2.Color(COLOR_ON);
 //  m_labelTrailingStop2.Font("Arial Black");
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Edit Trailing Stop Distance2" field                  |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateSpinEditTrailingStopDistance2(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+2*CONTROLS_GAP_X+EDIT_DATETIME_WIDTH+COMBO_WIDTH1;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+7*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+4*COMBO_HEIGHT;
   int x2=x1+SPIN_EDIT_WIDTH;
   int y2=y1+SPIN_EDIT_HEIGHT;
//--- create
   if(!m_spinEditTrailingStopDistance2.Create(m_chart_id,m_name+"spinEditTrailingStopDistance2",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_spinEditTrailingStopDistance2))
      return(false);
   m_spinEditTrailingStopDistance2.MaxValue(100);
   m_spinEditTrailingStopDistance2.setDigits(1);
   m_spinEditTrailingStopDistance2.Value(0);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Label Open Price2" label                             |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateLabelOpenPrice2(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+CONTROLS_GAP_X+EDIT_DATETIME_WIDTH;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+8*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+5*COMBO_HEIGHT;
   int x2=x1+LABEL_WIDTH;
   int y2=y1+LABEL_HEIGHT;
//--- create
   if(!m_labelOpenPrice2.Create(m_chart_id,m_name+"LabelOpenPrice2",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_labelOpenPrice2.Text("Open Price"))
      return(false);
   if(!Add(m_labelOpenPrice2))
      return(false);
   m_labelOpenPrice2.Color(COLOR_ON);
  // m_labelOpenPrice2.Font("Arial Black");
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Edit Open Price2" field                              |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateSpinEditOpenPrice2(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+2*CONTROLS_GAP_X+EDIT_DATETIME_WIDTH+COMBO_WIDTH1;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+8*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+5*COMBO_HEIGHT;
   int x2=x1+SPIN_EDIT_WIDTH;
   int y2=y1+SPIN_EDIT_HEIGHT;
//--- create
   if(!m_spinEditOpenPrice2.Create(m_chart_id,m_name+"spinEditOpenPrice2",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!Add(m_spinEditOpenPrice2))
      return(false);
   m_spinEditOpenPrice2.MaxValue(10000);
   m_spinEditOpenPrice2.setDigits(5);
   m_spinEditOpenPrice2.Value(0);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Button Modify Order" button                          |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateButtonModifyOrder(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+CONTROLS_GAP_X+EDIT_DATETIME_WIDTH;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+9*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+6*COMBO_HEIGHT;
   int x2=x1+COMBO_WIDTH1+CONTROLS_GAP_X+SPIN_EDIT_WIDTH;
   int y2=y1+BUTTON_HEIGHT;
//--- create
   if(!m_buttonModifyOrder.Create(m_chart_id,"RM ButtonModifyOrder",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_buttonModifyOrder.Text("Modify Order"))
      return(false);
   if(!Add(m_buttonModifyOrder))
      return(false);
   m_buttonModifyOrder.ColorBackground(clrOrangeRed);
   m_buttonModifyOrder.ColorBorder(clrOrangeRed);
   m_buttonModifyOrder.Locking(false);
   m_buttonModifyOrder.Color(clrWhite);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Button Close 50%" button                             |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateButtonClose50(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+CONTROLS_GAP_X+EDIT_DATETIME_WIDTH;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+10*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+6*COMBO_HEIGHT+BUTTON_HEIGHT;
   int x2=x1+int((COMBO_WIDTH1+CONTROLS_GAP_X+SPIN_EDIT_WIDTH-CONTROLS_GAP_X) / 2);
   int y2=y1+BUTTON_HEIGHT;
//--- create
   if(!m_buttonClose50.Create(m_chart_id,"RM ButtonClose50",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_buttonClose50.Text("Close 50%"))
      return(false);
   if(!Add(m_buttonClose50))
      return(false);
   m_buttonClose50.ColorBackground(clrBlueViolet);
   m_buttonClose50.ColorBorder(clrBlueViolet);
   m_buttonClose50.Locking(false);
   m_buttonClose50.Color(clrWhite);
   ObjectSetInteger(m_chart_id,"RM ButtonClose50",OBJPROP_ZORDER,999);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Button Close" button                                 |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateButtonClose11(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+2*CONTROLS_GAP_X+EDIT_DATETIME_WIDTH+int((COMBO_WIDTH1+CONTROLS_GAP_X+SPIN_EDIT_WIDTH-CONTROLS_GAP_X) / 2);
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+10*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+6*COMBO_HEIGHT+BUTTON_HEIGHT;
   int x2=x1+int((COMBO_WIDTH1+CONTROLS_GAP_X+SPIN_EDIT_WIDTH-CONTROLS_GAP_X) / 2);
   int y2=y1+BUTTON_HEIGHT;
//--- create
   if(!m_buttonClose11.Create(m_chart_id,"RM ButtonClose",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_buttonClose11.Text("Close"))
      return(false);
   if(!Add(m_buttonClose11))
      return(false);
   m_buttonClose11.ColorBackground(clrBlueViolet);
   m_buttonClose11.ColorBorder(clrBlueViolet);
   m_buttonClose11.Locking(false);
   m_buttonClose11.Color(clrWhite);
   ObjectSetInteger(m_chart_id,"RM ButtonClose",OBJPROP_ZORDER,999);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create the "Button Delete" button                                |
//+------------------------------------------------------------------+
bool CPanelDialog::CreateButtonDelete(void)
  {
//--- coordinates
   int x1=INDENT_LEFT+3*RECT_INDENT_LEFT+CONTROLS_GAP_X+EDIT_DATETIME_WIDTH;
   int y1=INDENT_TOP+2.5*LABEL_HEIGHT+10*CONTROLS_GAP_Y+RECTANGLE_TRADE_HEIGHT+RECT_INDENT_TOP+6*COMBO_HEIGHT+BUTTON_HEIGHT;
   int x2=x1+COMBO_WIDTH1+CONTROLS_GAP_X+SPIN_EDIT_WIDTH;
   int y2=y1+BUTTON_HEIGHT;
//--- create
   if(!m_buttonDelete.Create(m_chart_id,"RM ButtonDelete",m_subwin,x1,y1,x2,y2))
      return(false);
   if(!m_buttonDelete.Text("Delete"))
      return(false);
   if(!Add(m_buttonDelete))
      return(false);
   m_buttonDelete.ColorBackground(clrBlueViolet);
   m_buttonDelete.ColorBorder(clrBlueViolet);
   m_buttonDelete.Locking(false);
   m_buttonDelete.Color(clrWhite);
   ObjectSetInteger(m_chart_id,"RM ButtonDelete",OBJPROP_ZORDER,999);
//--- succeed
   return(true);
  }
//+------------------------------------------------------------------+
//| Create Trade Controls                                            |
//+------------------------------------------------------------------+
bool CPanelDialog::createTradeControls(void)
  {
   if(!CreateLabelTradeClicked())
      return(false);
   if(!CreateLabelModifyTradeUnclicked())
      return(false);
   if(!CreateButtonMoreActions())
      return(false); 
   if(!CreateRectangleTrade())
      return(false);
   if(!CreateRectangleLotSize())
      return(false);
   if(!CreateComboboxLotSize())
      return(false);
   if(!CreateSpinEditLotSize())
      return(false);
   if(!CreateRectangleBuySell())
      return(false);
   if(!CreateButtonBuy())
      return(false);
   if(!CreateButtonSell())
      return(false);
   if(!CreateEditSpread())
      return(false);
   if(!CreateLabelSpread())
      return(false);
   if(!CreateLabelSpreadValue())
      return(false); 
   if(!CreateLabelBuyAskValue())
      return(false);
   if(!CreateLabelSellBidValue())
      return(false); 
   if(!CreateRectangleSlTp())
      return(false);
   if(!CreateRadioNormal())
      return(false); 
   if(!CreateRadioReverse())
      return(false);
   if(!CreateComboboxStopLoss())
      return(false);
   if(!CreateSpinEditStopLoss())
      return(false); 
   if(!CreateComboboxTakeProfit())
      return(false);
   if(!CreateSpinEditTakeProfit())
      return(false); 
   if(!CreateRectangleBeTs())
      return(false);
   if(!CreateLabelBreakeven())
      return(false); 
   if(!CreateSpinEditBreakeven())
      return(false); 
   if(!CreateLabelTrailingStop())
      return(false); 
   if(!CreateSpinEditTrailingStop())
      return(false); 
   if(!CreateLabelTrailingStopDistance())
      return(false); 
   if(!CreateSpinEditTrailingStopDistance())
      return(false);
   if(!CreateLabelPendingOrder())
      return(false); 
   if(!CreateRectanglePending())
      return(false);
   if(!CreateComboboxDistance())
      return(false);
   if(!CreateSpinEditDistance())
      return(false);
   if(!CreateComboboxPendingType())
      return(false);
   if(!CreateButtonPlacePending())
      return(false);
   if(!CreateRectanglePreview())
      return(false);
   if(!CreateLabelPreview())
      return(false);
   if(!CreateComboboxOrdersType())
      return(false);
   if(!CreateRadioOn())
      return(false);
   if(!CreateRadioOff())
      return(false);
   if(!CreateLabelLossOnSL())
      return(false);
   if(!CreateLabelLossOnSLValue())
      return(false);
   if(!CreateLabelProfitOnTP())
      return(false);
   if(!CreateLabelProfitOnTPValue())
      return(false);
   if(!CreateLabelLotSize1())
      return(false);
   if(!CreateLabelLotSize1Value())
      return(false);
   if(!CreateLabelMargin())
      return(false);
   if(!CreateLabelMarginValue())
      return(false);
      
   if (m_radioOn.State())
    {
     m_labelLossOnSL.Show();
     m_labelLossOnSLValue.Show();
     m_labelProfitOnTP.Show();
     m_labelProfitOnTPValue.Show();
     m_labelLotSize1.Show();
     m_labelLotSize1Value.Show();
     m_labelMargin.Show();
     m_labelMarginValue.Show();
    }
   else
    {
     m_labelLossOnSL.Hide();
     m_labelLossOnSLValue.Hide();
     m_labelProfitOnTP.Hide();
     m_labelProfitOnTPValue.Hide();
     m_labelLotSize1.Hide();
     m_labelLotSize1Value.Hide();
     m_labelMargin.Hide();
     m_labelMarginValue.Hide();
    }
   return true;
  }
//+------------------------------------------------------------------+
//| Event handler Label Clickable Modify Trade                       |
//+------------------------------------------------------------------+
void CPanelDialog::OnClickLabelTradeUnclicked(void)
  {
   tradeMode = true;

   checkTrades();
    
   Delete(m_labelModifyTradeClicked);
   m_labelModifyTradeClicked.Destroy();
   Delete(m_labelTradeUnclicked);
   m_labelTradeUnclicked.Destroy();
   Delete(m_rectangleModifyTrade);
   m_rectangleModifyTrade.Destroy();
   Delete(m_rectangleOrderDetails);
   m_rectangleOrderDetails.Destroy(); 
   Delete(m_labelSelectOrder);
   m_labelSelectOrder.Destroy();
   Delete(m_comboboxSelectOrder);
   m_comboboxSelectOrder.Destroy();
   Delete(m_labelOrderDetails);
   m_labelOrderDetails.Destroy();
   Delete(m_labelSymbol);
   m_labelSymbol.Destroy();
   Delete(m_labelAction);
   m_labelAction.Destroy();
   Delete(m_labelSize);
   m_labelSize.Destroy();
   Delete(m_labelOpenPrice);
   m_labelOpenPrice.Destroy();
   Delete(m_labelTakeProfit);
   m_labelTakeProfit.Destroy();
   Delete(m_labelStopLoss);
   m_labelStopLoss.Destroy();
   Delete(m_labelComment);
   m_labelComment.Destroy();
   Delete(m_labelTrailStop);
   m_labelTrailStop.Destroy();
   Delete(m_labelTrailStopDistance);
   m_labelTrailStopDistance.Destroy();
   Delete(m_labelBreakEven);
   m_labelBreakEven.Destroy();
   Delete(m_labelOrderExpires);
   m_labelOrderExpires.Destroy();
   Delete(m_labelSymbolValue);
   m_labelSymbolValue.Destroy();
   Delete(m_labelActionValue);
   m_labelActionValue.Destroy();
   Delete(m_labelSizeValue);
   m_labelSizeValue.Destroy();
   Delete(m_labelOpenPriceValue);
   m_labelOpenPriceValue.Destroy();
   Delete(m_labelTakeProfitValue);
   m_labelTakeProfitValue.Destroy();
   Delete(m_labelStopLossValue);
   m_labelStopLossValue.Destroy();
   Delete(m_labelCommentValue);
   m_labelCommentValue.Destroy();
   Delete(m_labelTrailStopValue);
   m_labelTrailStopValue.Destroy();
   Delete(m_labelTrailStopDistanceValue);
   m_labelTrailStopDistanceValue.Destroy();
   Delete(m_labelBreakEvenValue);
   m_labelBreakEvenValue.Destroy();
   Delete(m_labelOrderExpiresValue);
   m_labelOrderExpiresValue.Destroy();
   Delete(m_rectangleModifyOrder);
   m_rectangleModifyOrder.Destroy();
   Delete(m_labelModifyOrder);
   m_labelModifyOrder.Destroy();
   Delete(m_comboboxSL);
   m_comboboxSL.Destroy();
   Delete(m_spinEditSL);
   m_spinEditSL.Destroy();
   Delete(m_comboboxTP);
   m_comboboxTP.Destroy();
   Delete(m_spinEditTP);
   m_spinEditTP.Destroy();
   Delete(m_labelBreakeven2);
   m_labelBreakeven2.Destroy();
   Delete(m_spinEditBreakeven2);
   m_spinEditBreakeven2.Destroy();
   Delete(m_labelTrailingStop2);
   m_labelTrailingStop2.Destroy();
   Delete(m_spinEditTrailingStop2);
   m_spinEditTrailingStop2.Destroy();
   Delete(m_labelTrailingStopDistance2);
   m_labelTrailingStopDistance2.Destroy();
   Delete(m_spinEditTrailingStopDistance2);
   m_spinEditTrailingStopDistance2.Destroy();
   Delete(m_labelOpenPrice2);
   m_labelOpenPrice2.Destroy();
   Delete(m_spinEditOpenPrice2);
   m_spinEditOpenPrice2.Destroy();
   Delete(m_buttonModifyOrder);
   m_buttonModifyOrder.Destroy();
   Delete(m_buttonClose50);
   m_buttonClose50.Destroy();
   Delete(m_buttonClose11);
   m_buttonClose11.Destroy();
   Delete(m_buttonDelete);
   m_buttonDelete.Destroy();
    
   createTradeControls();

   if (m_radioOn.State()) calculateTrade();
  }
//+------------------------------------------------------------------+
//| Event handler Label Clickable Trade                              |
//+------------------------------------------------------------------+
void CPanelDialog::OnClickLabelModifyTradeUnclicked(void)
  {
   tradeMode = false;

   checkTrades();
   
   Delete(m_labelTradeClicked);
   m_labelTradeClicked.Destroy();
   Delete(m_labelModifyTradeUnclicked);
   m_labelModifyTradeUnclicked.Destroy();
   Delete(m_buttonMoreActions);
   m_buttonMoreActions.Destroy();
   Delete(m_rectangleTrade);
   m_rectangleTrade.Destroy();
   Delete(m_rectangleLotSize);
   m_rectangleLotSize.Destroy();  
   Delete(m_comboboxLotSizeDropdown);
   m_comboboxLotSizeDropdown.Destroy();
   Delete(m_spinEditLotSize);
   m_spinEditLotSize.Destroy();
   Delete(m_rectangleBuySell);
   m_rectangleBuySell.Destroy();
   Delete(m_buttonBuy);
   m_buttonBuy.Destroy();
   Delete(m_buttonSell);
   m_buttonSell.Destroy();
   Delete(m_editSpread);
   m_editSpread.Destroy();
   Delete(m_labelSpread);
   m_labelSpread.Destroy();
   Delete(m_labelSpreadValue);
   m_labelSpreadValue.Destroy();
   Delete(m_labelSellBidValue);
   m_labelSellBidValue.Destroy();
   Delete(m_labelBuyAskValue);
   m_labelBuyAskValue.Destroy();
   Delete(m_rectangleSlTp);
   m_rectangleSlTp.Destroy();
   Delete(m_radioNormal);
   m_radioNormal.Destroy();
   Delete(m_radioReverse);
   m_radioReverse.Destroy();
   Delete(m_comboboxStopLoss);
   m_comboboxStopLoss.Destroy();
   Delete(m_spinEditStopLoss);
   m_spinEditStopLoss.Destroy();
   Delete(m_comboboxTakeProfit);
   m_comboboxTakeProfit.Destroy();
   Delete(m_spinEditTakeProfit);
   m_spinEditTakeProfit.Destroy();
   Delete(m_rectangleBeTs);
   m_rectangleBeTs.Destroy();
   Delete(m_labelBreakeven);
   m_labelBreakeven.Destroy();
   Delete(m_spinEditBreakeven);
   m_spinEditBreakeven.Destroy();
   Delete(m_labelTrailingStop);
   m_labelTrailingStop.Destroy();
   Delete(m_spinEditTrailingStop);
   m_spinEditTrailingStop.Destroy();
   Delete(m_labelTrailingStopDistance);
   m_labelTrailingStopDistance.Destroy();
   Delete(m_spinEditTrailingStopDistance);
   m_spinEditTrailingStopDistance.Destroy();  

   Delete(m_labelPendingOrder);
   m_labelPendingOrder.Destroy();
   Delete(m_rectanglePending);
   m_rectanglePending.Destroy();
   Delete(m_comboboxDistance);
   m_comboboxDistance.Destroy();
   Delete(m_spinEditDistance);
   m_spinEditDistance.Destroy();
   Delete(m_comboboxPendingType);
   m_comboboxPendingType.Destroy();
   Delete(m_buttonPlacePending);
   m_buttonPlacePending.Destroy();
   Delete(m_rectanglePreview);
   m_rectanglePreview.Destroy();
   Delete(m_labelPreview);
   m_labelPreview.Destroy();
   Delete(m_comboboxOrdersType);
   m_comboboxOrdersType.Destroy();
   Delete(m_radioOn);
   m_radioOn.Destroy();
   Delete(m_radioOff);
   m_radioOff.Destroy();
   Delete(m_labelLossOnSL);
   m_labelLossOnSL.Destroy();
   Delete(m_labelLossOnSLValue);
   m_labelLossOnSLValue.Destroy();
   Delete(m_labelProfitOnTP);
   m_labelProfitOnTP.Destroy();
   Delete(m_labelProfitOnTPValue);
   m_labelProfitOnTPValue.Destroy();
   Delete(m_labelLotSize1);
   m_labelLotSize1.Destroy();
   Delete(m_labelLotSize1Value);
   m_labelLotSize1Value.Destroy();
   Delete(m_labelMargin);
   m_labelMargin.Destroy();
   Delete(m_labelMarginValue);
   m_labelMarginValue.Destroy();
     
   ObjectDelete(0, openPriceLine);
   ObjectDelete(0, openPriceLabel);
   ObjectDelete(0, slLine);
   ObjectDelete(0, tpLine);
     
   m_rectangle.Destroy();
   m_buttonCloseAllTrades.Destroy();
   m_buttonDeleteAllPending.Destroy();
   m_buttonClose50Volume.Destroy();
   m_buttonCloseAllLoss.Destroy();
   m_buttonCloseAllProfit.Destroy();
   m_buttonCloseAllBuy.Destroy();
   m_buttonCloseAllSell.Destroy();
   m_buttonMoreActions.Pressed(false);
   
   CreateLabelModifyTradeClicked();
   CreateLabelTradeUnclicked(); 
   CreateRectangleModifyTrade();
   CreateRectangleOrderDetails(); 
   CreateLabelSelectOrder();
   CreateComboboxSelectOrder();
   CreateLabelOrderDetails();
   CreateLabelSymbol();
   CreateLabelAction();
   CreateLabelSize();
   CreateLabelOpenPrice();
   CreateLabelTakeProfit();
   CreateLabelStopLoss();
   CreateLabelComment();
   CreateLabelTrailStop();
   CreateLabelTrailStopDistance();
   CreateLabelBreakEven();
   CreateLabelOrderExpires();
   CreateLabelSymbolValue();
   CreateLabelActionValue();
   CreateLabelSizeValue();
   CreateLabelOpenPriceValue();
   CreateLabelTakeProfitValue();
   CreateLabelStopLossValue();
   CreateLabelCommentValue();
   CreateLabelTrailStopValue();
   CreateLabelTrailStopDistanceValue();
   CreateLabelBreakEvenValue();
   CreateLabelOrderExpiresValue();
   CreateRectangleModifyOrder();
   CreateLabelModifyOrder();
   CreateComboboxSL();
   CreateSpinEditSL();
   CreateComboboxTP();
   CreateSpinEditTP();
   CreateLabelBreakeven2();
   CreateSpinEditBreakeven2();
   CreateLabelTrailingStop2();
   CreateSpinEditTrailingStop2();
   CreateLabelTrailingStopDistance2();
   CreateSpinEditTrailingStopDistance2();
   CreateLabelOpenPrice2();
   CreateSpinEditOpenPrice2();
   CreateButtonModifyOrder();
   CreateButtonClose50();
   CreateButtonClose11();
   CreateButtonDelete();
      
   m_labelSymbolValue.Text("");
   m_labelActionValue.Text("");
   m_labelSizeValue.Text("");
   m_labelOpenPriceValue.Text("");
   m_labelTakeProfitValue.Text("");
   m_labelStopLossValue.Text("");
   m_labelCommentValue.Text("");
   m_labelTrailStopValue.Text("");
   m_labelTrailStopDistanceValue.Text("");
   m_labelBreakEvenValue.Text("");
   m_labelOrderExpiresValue.Text("");

   m_comboboxSelectOrder.ItemsClear();

   if (numberOfOpenedBuySell() + numberOfPending() == 0)
    {
     m_comboboxSelectOrder.AddItem("NA", 0);
     m_comboboxSelectOrder.Select(0);
    }
   else
    {
     m_comboboxSelectOrder.AddItem("Please select an order", 0);
     m_comboboxSelectOrder.Select(0);
     for (int i = OrdersTotal() - 1; i >= 0; i--)
      {
       if (!OrderSelect(i,SELECT_BY_POS)) continue;
       if (OrderSymbol() != _Symbol) continue;
       if (OrderMagicNumber() != magic) continue;
       m_comboboxSelectOrder.AddItem(IntegerToString(OrderTicket()) + "  " + ordersType(OrderType()) + " #" + _Symbol, OrderTicket());
      }
    }
  }
//+------------------------------------------------------------------+
//| Event handler Combobox Lot Size                                  |
//+------------------------------------------------------------------+
void CPanelDialog::OnChangeComboLotSize(void)
  {
   if (m_comboboxLotSizeDropdown.Select() == "Lot Size (Fixed)")
    {
     m_spinEditLotSize.MaxValue(10000);
     m_spinEditLotSize.setDigits(lotsDigits);
     m_spinEditLotSize.Value(lot);
    }
   else if(m_comboboxLotSizeDropdown.Select() == "Risk (%)")
    {
     m_spinEditLotSize.MaxValue(100);
     m_spinEditLotSize.setDigits(2);
     m_spinEditLotSize.Value(riskPers);
    }
   else if(m_comboboxLotSizeDropdown.Select() == "Risk in USD ($)")
    {
     m_spinEditLotSize.MaxValue(1000000000);
     m_spinEditLotSize.setDigits(2);
     m_spinEditLotSize.Value(riskUsd);
    }
   if (m_radioOn.State()) calculateTrade();
  }
//+------------------------------------------------------------------+
//| Event handler Spin Edit Lot Size                                 |
//+------------------------------------------------------------------+
void CPanelDialog::OnChangeSpinEditLotSize(void)
  {
   if (m_comboboxLotSizeDropdown.Select() == "Lot Size (Fixed)")
    {
     lot = m_spinEditLotSize.Value();
    }
   else if(m_comboboxLotSizeDropdown.Select() == "Risk (%)")
    {
     riskPers = m_spinEditLotSize.Value();
     riskUsd = riskPers * AccountEquity() / 100;
     lot = riskLotCalculation(riskPers, StopLoss);
    }
   else if(m_comboboxLotSizeDropdown.Select() == "Risk in USD ($)")
    {
     riskUsd = m_spinEditLotSize.Value();
     riskPers = riskUsd / AccountEquity() * 100;
     lot = riskLotCalculation(riskPers, StopLoss);
    }
   if (m_radioOn.State()) calculateTrade();
  }
//+------------------------------------------------------------------+
//| Event handler Combobox Stop Loss                                 |
//+------------------------------------------------------------------+
void CPanelDialog::OnChangeComboStopLoss(void)
  {
   if (m_comboboxStopLoss.Select() == "Stop Loss in pips")
    {
     m_spinEditStopLoss.MaxValue(100000);
     m_spinEditStopLoss.setDigits(digitsAfterDot);
     m_spinEditStopLoss.Value(StopLoss);
     
    }
   else if (m_comboboxStopLoss.Select() == "Stop Loss at price")
    {
     m_spinEditStopLoss.MaxValue(int(Bid * 2));
     m_spinEditStopLoss.setDigits(Digits);
     m_spinEditStopLoss.Value(Bid);
    }
   if (m_radioOn.State()) calculateTrade();
  }
//+------------------------------------------------------------------+
//| Event handler Spin Edit Stop Loss                                |
//+------------------------------------------------------------------+
void CPanelDialog::OnChangeSpinEditStopLoss(void)
  {
   if (m_comboboxStopLoss.Select() == "Stop Loss in pips")
    {
     StopLoss = m_spinEditStopLoss.Value();
     
     if(m_comboboxLotSizeDropdown.Select() == "Risk (%)")
      {
       lot = riskLotCalculation(riskPers, StopLoss);
      }
     else if(m_comboboxLotSizeDropdown.Select() == "Risk in USD ($)")
      {
       riskPers = riskUsd / AccountEquity() * 100;
       lot = riskLotCalculation(riskPers, StopLoss);
      }
    }
   else if (m_comboboxStopLoss.Select() == "Stop Loss at price")
    {
     StopLossPrice = m_spinEditStopLoss.Value();
    }
   if (m_radioOn.State()) calculateTrade();
  }
//+------------------------------------------------------------------+
//| Event handler Combobox Take Profit                               |
//+------------------------------------------------------------------+
void CPanelDialog::OnChangeComboTakeProfit(void)
  {
   if (m_comboboxTakeProfit.Select() == "Take Profit in pips")
    {
     m_spinEditTakeProfit.MaxValue(100000);
     m_spinEditTakeProfit.setDigits(digitsAfterDot);
     m_spinEditTakeProfit.Value(TakeProfit);
    }
   else if (m_comboboxTakeProfit.Select() == "Take Profit at price")
    {
     m_spinEditTakeProfit.MaxValue(int(Bid * 2));
     m_spinEditTakeProfit.setDigits(Digits);
     m_spinEditTakeProfit.Value(Bid);
    }
   else if (m_comboboxTakeProfit.Select() == "Take Profit at seconds")
    {
     m_spinEditTakeProfit.MaxValue(1000000);
     m_spinEditTakeProfit.setDigits(0);
     m_spinEditTakeProfit.Value(TakeProfitSeconds);
    }
   if (m_radioOn.State()) calculateTrade();
  }
//+------------------------------------------------------------------+
//| Event handler Spin Edit Take Profit                              |
//+------------------------------------------------------------------+
void CPanelDialog::OnChangeSpinEditTakeProfit(void)
  {
   if (m_comboboxTakeProfit.Select() == "Take Profit in pips")
    {
     TakeProfit = m_spinEditTakeProfit.Value();
    }
   else if (m_comboboxTakeProfit.Select() == "Take Profit at price")
    {
     TakeProfitPrice = m_spinEditTakeProfit.Value();
    }
   else if (m_comboboxTakeProfit.Select() == "Take Profit at seconds")
    {
     TakeProfitSeconds = m_spinEditTakeProfit.Value();
    }
   if (m_radioOn.State()) calculateTrade();
  }
//+------------------------------------------------------------------+
//| Event handler Button Buy                                         |
//+------------------------------------------------------------------+
void CPanelDialog::OnClickButtonBuy(void)
  {
   if (tradeMode)
    {
     if (m_comboboxTakeProfit.Select() == "Take Profit at price")
      {
       TakeProfit = NormalizeDouble((m_spinEditTakeProfit.Value() - Ask) / _point, digitsAfterDot);
       if (TakeProfit < 0) 
        {
         Alert ("Take Profit can't be set at ", m_spinEditTakeProfit.Value());
         return;
        }
      }
     else if (m_comboboxTakeProfit.Select() == "Take Profit at seconds")
      {
       TakeProfit = 0;
      }
     if (m_comboboxStopLoss.Select() == "Stop Loss at price")
      {
       StopLoss = NormalizeDouble((Ask - m_spinEditStopLoss.Value()) / _point, digitsAfterDot);
       if (StopLoss < 0)
        {
         Alert ("Stop Loss can't be set at ", m_spinEditStopLoss.Value());
         return;
        }
      }
     if(m_comboboxLotSizeDropdown.Select() == "Risk (%)")
      {
       riskPers = m_spinEditLotSize.Value();
       riskUsd = riskPers * AccountEquity() / 100;
       lot = riskLotCalculation(riskPers, StopLoss);
      }
     else if(m_comboboxLotSizeDropdown.Select() == "Risk in USD ($)")
      {
       riskUsd = m_spinEditLotSize.Value();
       riskPers = riskUsd / AccountEquity() * 100;
       lot = riskLotCalculation(riskPers, StopLoss);
      }
     if (m_radioReverse.State())
      {
       closeSell();
      }  
     int ticket = openBuy();
     datetime expir = 0;
     if (m_comboboxTakeProfit.Select() == "Take Profit at seconds") expir = TimeCurrent() + datetime(m_spinEditTakeProfit.Value());
     addNewTrade(ticket, m_spinEditTrailingStop.Value(), m_spinEditTrailingStopDistance.Value(), m_spinEditBreakeven.Value(), expir);
     checkTrades();
     refreshMoreActionsButtons();
    }
  }
//+------------------------------------------------------------------+
//| Event handler Button Sell                                        |
//+------------------------------------------------------------------+
void CPanelDialog::OnClickButtonSell(void)
  {
   if (tradeMode)
    {
     if (m_comboboxTakeProfit.Select() == "Take Profit at price")
      {
       TakeProfit = NormalizeDouble((Bid - m_spinEditTakeProfit.Value()) / _point, digitsAfterDot);
       if (TakeProfit < 0) 
        {
         Alert ("Take Profit can't be set at ", m_spinEditTakeProfit.Value());
         return;
        }
      }
     else if (m_comboboxTakeProfit.Select() == "Take Profit at seconds")
      {
       TakeProfit = 0;
      }
     if (m_comboboxStopLoss.Select() == "Stop Loss at price")
      {
       StopLoss = NormalizeDouble((m_spinEditStopLoss.Value() - Bid) / _point, digitsAfterDot);
       if (StopLoss < 0)
        {
         Alert ("Stop Loss can't be set at ", m_spinEditStopLoss.Value());
         return;
        }
      }
     if(m_comboboxLotSizeDropdown.Select() == "Risk (%)")
      {
       riskPers = m_spinEditLotSize.Value();
       riskUsd = riskPers * AccountEquity() / 100;
       lot = riskLotCalculation(riskPers, StopLoss);
      }
     else if(m_comboboxLotSizeDropdown.Select() == "Risk in USD ($)")
      {
       riskUsd = m_spinEditLotSize.Value();
       riskPers = riskUsd / AccountEquity() * 100;
       lot = riskLotCalculation(riskPers, StopLoss);
      }
     if (m_radioReverse.State())
      {
       closeBuy();
      }
     int ticket = openSell();
     datetime expir = 0;
     if (m_comboboxTakeProfit.Select() == "Take Profit at seconds") expir = TimeCurrent() + datetime(m_spinEditTakeProfit.Value());
     addNewTrade(ticket, m_spinEditTrailingStop.Value(), m_spinEditTrailingStopDistance.Value(), m_spinEditBreakeven.Value(), expir);
     checkTrades();
     refreshMoreActionsButtons();
    }
  }
//+------------------------------------------------------------------+
//| Event handler Button More Actions                                |
//+------------------------------------------------------------------+
void CPanelDialog::OnClickButtonMoreActions(void)
  {
   if (m_buttonMoreActions.Pressed())
    {
     m_rectangle.Destroy();
     m_buttonCloseAllTrades.Destroy();
     m_buttonDeleteAllPending.Destroy();
     m_buttonClose50Volume.Destroy();
     m_buttonCloseAllLoss.Destroy();
     m_buttonCloseAllProfit.Destroy();
     m_buttonCloseAllBuy.Destroy();
     m_buttonCloseAllSell.Destroy();
    
     tradesQuantity = numberOfOpenedBuySellAll();
     pendingQuantity = numberOfPendingAll();
     tradesInLoss = numderInLossAll();
     tradesInProfit = numberInProfitAll();
     tradesBuy = numberOfOpenedBuyAll();
     tradesSell = numberOfOpenedSellAll();
     
     CreateRect();
     CreateButtonCloseAllTrades();
     CreateButtonDeleteAllPending();
     CreateButtonClose50Volume();
     CreateButtonCloseAllLoss();
     CreateButtonCloseAllProfit();
     CreateButtonCloseAllBuy();
     CreateButtonCloseAllSell();
    }
   else 
    {
     m_rectangle.Destroy();
     m_buttonCloseAllTrades.Destroy();
     m_buttonDeleteAllPending.Destroy();
     m_buttonClose50Volume.Destroy();
     m_buttonCloseAllLoss.Destroy();
     m_buttonCloseAllProfit.Destroy();
     m_buttonCloseAllBuy.Destroy();
     m_buttonCloseAllSell.Destroy();

    }
  }
//+------------------------------------------------------------------+
//| Event handler Radio Normal Actions                               |
//+------------------------------------------------------------------+
void CPanelDialog::OnChangeRadioNormal(void)
  {
   if (tradeMode)
    {
     m_radioReverse.State(false);
    }
  }
//+------------------------------------------------------------------+
//| Event handler Radio Reverse Actions                              |
//+------------------------------------------------------------------+
void CPanelDialog::OnChangeRadioReverse(void)
  {
   if (tradeMode)
    {
     m_radioNormal.State(false);
    }
  }
//+------------------------------------------------------------------+
//| Event handler Combobox Distance                                  |
//+------------------------------------------------------------------+
void CPanelDialog::OnChangeComboboxDistance(void)
  {
   if (m_comboboxDistance.Select() == "Exact entry price")
    {
     if (m_comboboxPendingType.Select() == "BUY&SELL (Straddle)")
      {
       m_comboboxDistance.Select(0);
      }
     m_spinEditDistance.MaxValue(int(Bid * 10));
     m_spinEditDistance.setDigits(Digits);
     m_spinEditDistance.Value(Bid);

    }
   if (m_comboboxDistance.Select() == "Distance in pips")
    {
     m_spinEditDistance.MaxValue(1000000);
     m_spinEditDistance.setDigits(1);
     m_spinEditDistance.Value(pendDist);
    }
   if (m_radioOn.State()) calculateTrade();
  }
//+------------------------------------------------------------------+
//| Event handler Spin Edit Distance                                 |
//+------------------------------------------------------------------+
void CPanelDialog::OnChangeSpinEditDistance(void)
  {
   if (m_comboboxDistance.Select() == "Distance in pips")
    {
     pendDist = m_spinEditDistance.Value();
    }
   if (m_radioOn.State()) calculateTrade();
  }
//+------------------------------------------------------------------+
//| Event handler Combobox Select Order                              |
//+------------------------------------------------------------------+
void CPanelDialog::OnChangeComboboxSelectOrder(void)
  {
   int ticket = int(m_comboboxSelectOrder.Value());
   int orderType = 0;
   double orderLot = 0;
   double orderOpenPrice = 0;
   double orderTP = 0;
   double orderSL = 0;
   double orderTS = 0;
   double orderTSD = 0;
   double orderBE = 0;
   datetime orderExpire = 0;
   
   if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
    {
     m_labelSymbolValue.Text(_Symbol);
     orderType = OrderType();
     m_labelActionValue.Text(ordersType(orderType));
     orderLot = OrderLots();
     m_labelSizeValue.Text(DoubleToStr(orderLot, lotsDigits));
     orderOpenPrice = OrderOpenPrice();
     m_labelOpenPriceValue.Text(DoubleToStr(orderOpenPrice, Digits));
     orderTP = OrderTakeProfit();
     m_labelTakeProfitValue.Text(DoubleToStr(orderTP, Digits));
     orderSL = OrderStopLoss();
     m_labelStopLossValue.Text(DoubleToStr(orderSL, Digits));
     m_labelCommentValue.Text(OrderComment());
     
     for (int j = 0; j < ArraySize(tickets); j++)
      {
       if (tickets[j] == ticket)
        {
         orderTS = TS[j];
         orderTSD = TSD[j];
         orderBE = BE[j];
         orderExpire = expire[j];

         m_labelTrailStopValue.Text("none");
         m_labelTrailStopDistanceValue.Text("none");
         m_labelBreakEvenValue.Text("none");
         m_labelOrderExpiresValue.Text("NA");
         if (orderTS > 0) m_labelTrailStopValue.Text(DoubleToStr(orderTS, 1) + " pips");
         if (orderTSD > 0) m_labelTrailStopDistanceValue.Text(DoubleToStr(orderTSD, 1) + " pips");
         if (orderBE > 0) m_labelBreakEvenValue.Text(DoubleToStr(orderBE, 1) + " pips");
         if (orderExpire > 0) m_labelOrderExpiresValue.Text(TimeToStr(orderExpire, TIME_DATE|TIME_MINUTES));
         break;
        }
      }
     if (orderType == OP_BUY || orderType == OP_SELL)
      {
       Delete(m_buttonDelete);
       m_buttonDelete.Destroy();
       CreateButtonClose50();
       CreateButtonClose11();
      }
     else
      {
       Delete(m_buttonClose50);
       m_buttonClose50.Destroy();
       Delete(m_buttonClose11);
       m_buttonClose11.Destroy();
       CreateButtonDelete();
       
      }
      m_comboboxSL.SelectByText("Stop Loss at price");
      m_spinEditSL.setDigits(Digits);
      m_spinEditSL.Value(orderSL);
      
      m_comboboxTP.SelectByText("Take Profit at price");
      m_spinEditTP.setDigits(Digits);
      m_spinEditTP.Value(orderTP);
      
      m_spinEditBreakeven2.Value(orderBE);
      m_spinEditTrailingStop2.Value(orderTS);
      m_spinEditTrailingStopDistance2.Value(orderTSD);
      m_spinEditOpenPrice2.Value(orderOpenPrice);
    }
   else
    {
     m_labelSymbolValue.Text("");
     m_labelActionValue.Text("");
     m_labelSizeValue.Text("");
     m_labelOpenPriceValue.Text("");
     m_labelTakeProfitValue.Text("");
     m_labelStopLossValue.Text("");
     m_labelCommentValue.Text("");
     m_labelTrailStopValue.Text("");
     m_labelTrailStopDistanceValue.Text("");
     m_labelBreakEvenValue.Text("");
     m_labelOrderExpiresValue.Text("");
     
     Delete(m_buttonDelete);
     m_buttonDelete.Destroy();
     Delete(m_buttonClose50);
     m_buttonClose50.Destroy();
     Delete(m_buttonClose11);
     m_buttonClose11.Destroy();

    }
  }
//+------------------------------------------------------------------+
//| Correction for time field                                        |
//+------------------------------------------------------------------+
string correction(string value, long maxValue)
  {
   long Value = StringToInteger(value);
   if (value == "" || Value == 0) return "00";
   if (Value > maxValue || Value < 0) return "00";
   if (Value < 10) return "0" + value;
   return value;
  }
//+------------------------------------------------------------------+
//| Event handler Combobox Select Order                              |
//+------------------------------------------------------------------+
void CPanelDialog::OnChangeComboboxPendingType(void)
  {
   if (m_comboboxPendingType.Select() == "BUY&SELL (Straddle)")
    {
     m_comboboxDistance.Select(0);
    }
  }
//+------------------------------------------------------------------+
//| Event handler Button Place Pending                               |
//+------------------------------------------------------------------+
void CPanelDialog::OnClickButtonPlacePending(void)
  {
   if (tradeMode)
    {
     double openPrice;
     if (m_comboboxPendingType.Select() == "BUY STOP")
      {
       if (m_comboboxDistance.Select() == "Exact entry price")
        {
         openPrice = m_spinEditDistance.Value();
        }
       else 
        {
         openPrice = Ask + pendDist * _point;
        }
       if (openPrice <= Ask)
        {
         Alert ("Can't place pending order. Wrong entry price.");
         return;
        }
       // open Price is correct
       if (m_comboboxTakeProfit.Select() == "Take Profit at price")
        {
         TakeProfit = NormalizeDouble((m_spinEditTakeProfit.Value() - openPrice) / _point, digitsAfterDot);
         if (TakeProfit < 0) 
          {
           Alert ("Take Profit can't be set at ", m_spinEditTakeProfit.Value());
           return;
          }
        }
       else if (m_comboboxTakeProfit.Select() == "Take Profit at seconds")
        {
         TakeProfit = 0;
        }
       if (m_comboboxStopLoss.Select() == "Stop Loss at price")
        {
         StopLoss = NormalizeDouble((openPrice - m_spinEditStopLoss.Value()) / _point, digitsAfterDot);
         if (StopLoss < 0)
          {
           Alert ("Stop Loss can't be set at ", m_spinEditStopLoss.Value());
           return;
          }
        }
       if(m_comboboxLotSizeDropdown.Select() == "Risk (%)")
        {
         riskPers = m_spinEditLotSize.Value();
         riskUsd = riskPers * AccountEquity() / 100;
         lot = riskLotCalculation(riskPers, StopLoss);
        }
       else if(m_comboboxLotSizeDropdown.Select() == "Risk in USD ($)")
        {
         riskUsd = m_spinEditLotSize.Value();
         riskPers = riskUsd / AccountEquity() * 100;
         lot = riskLotCalculation(riskPers, StopLoss);
        }  
       int ticket = openBuyStop(openPrice);
       datetime expir = 0;
  //     if (m_comboboxTakeProfit.Select() == "Take Profit at seconds") expir = TimeCurrent() + datetime(m_spinEditTakeProfit.Value());
       addNewTrade(ticket, m_spinEditTrailingStop.Value(), m_spinEditTrailingStopDistance.Value(), m_spinEditBreakeven.Value(), expir);
       checkTrades();
      }
     if (m_comboboxPendingType.Select() == "SELL STOP")
      {
       if (m_comboboxDistance.Select() == "Exact entry price")
        {
         openPrice = m_spinEditDistance.Value();
        }
       else 
        {
         openPrice = Bid - pendDist * _point;
        }
       if (openPrice >= Bid)
        {
         Alert ("Can't place pending order. Wrong entry price.");
         return;
        }
       // open Price is correct
       if (m_comboboxTakeProfit.Select() == "Take Profit at price")
        {
         TakeProfit = NormalizeDouble((openPrice - m_spinEditTakeProfit.Value()) / _point, digitsAfterDot);
         if (TakeProfit < 0) 
          {
           Alert ("Take Profit can't be set at ", m_spinEditTakeProfit.Value());
           return;
          }
        }
       else if (m_comboboxTakeProfit.Select() == "Take Profit at seconds")
        {
         TakeProfit = 0;
        }
       if (m_comboboxStopLoss.Select() == "Stop Loss at price")
        {
         StopLoss = NormalizeDouble((m_spinEditStopLoss.Value() - openPrice) / _point, digitsAfterDot);
         if (StopLoss < 0)
          {
           Alert ("Stop Loss can't be set at ", m_spinEditStopLoss.Value());
           return;
          }
        }
       if(m_comboboxLotSizeDropdown.Select() == "Risk (%)")
        {
         riskPers = m_spinEditLotSize.Value();
         riskUsd = riskPers * AccountEquity() / 100;
         lot = riskLotCalculation(riskPers, StopLoss);
        }
       else if(m_comboboxLotSizeDropdown.Select() == "Risk in USD ($)")
        {
         riskUsd = m_spinEditLotSize.Value();
         riskPers = riskUsd / AccountEquity() * 100;
         lot = riskLotCalculation(riskPers, StopLoss);
        }  
       int ticket = openSellStop(openPrice);
       datetime expir = 0;
  //     if (m_comboboxTakeProfit.Select() == "Take Profit at seconds") expir = TimeCurrent() + datetime(m_spinEditTakeProfit.Value());
       addNewTrade(ticket, m_spinEditTrailingStop.Value(), m_spinEditTrailingStopDistance.Value(), m_spinEditBreakeven.Value(), expir);
       checkTrades();
      }
     if (m_comboboxPendingType.Select() == "BUY LIMIT")
      {
       if (m_comboboxDistance.Select() == "Exact entry price")
        {
         openPrice = m_spinEditDistance.Value();
        }
       else 
        {
         openPrice = Ask - pendDist * _point;
        }
       if (openPrice >= Ask)
        {
         Alert ("Can't place pending order. Wrong entry price.");
         return;
        }
       // open Price is correct
       if (m_comboboxTakeProfit.Select() == "Take Profit at price")
        {
         TakeProfit = NormalizeDouble((m_spinEditTakeProfit.Value() - openPrice) / _point, digitsAfterDot);
         if (TakeProfit < 0) 
          {
           Alert ("Take Profit can't be set at ", m_spinEditTakeProfit.Value());
           return;
          }
        }
       else if (m_comboboxTakeProfit.Select() == "Take Profit at seconds")
        {
         TakeProfit = 0;
        }
       if (m_comboboxStopLoss.Select() == "Stop Loss at price")
        {
         StopLoss = NormalizeDouble((openPrice - m_spinEditStopLoss.Value()) / _point, digitsAfterDot);
         if (StopLoss < 0)
          {
           Alert ("Stop Loss can't be set at ", m_spinEditStopLoss.Value());
           return;
          }
        }
       if(m_comboboxLotSizeDropdown.Select() == "Risk (%)")
        {
         riskPers = m_spinEditLotSize.Value();
         riskUsd = riskPers * AccountEquity() / 100;
         lot = riskLotCalculation(riskPers, StopLoss);
        }
       else if(m_comboboxLotSizeDropdown.Select() == "Risk in USD ($)")
        {
         riskUsd = m_spinEditLotSize.Value();
         riskPers = riskUsd / AccountEquity() * 100;
         lot = riskLotCalculation(riskPers, StopLoss);
        }  
       int ticket = openBuyLimit(openPrice);
       datetime expir = 0;
  //     if (m_comboboxTakeProfit.Select() == "Take Profit at seconds") expir = TimeCurrent() + datetime(m_spinEditTakeProfit.Value());
       addNewTrade(ticket, m_spinEditTrailingStop.Value(), m_spinEditTrailingStopDistance.Value(), m_spinEditBreakeven.Value(), expir);
       checkTrades();
      }
     if (m_comboboxPendingType.Select() == "SELL LIMIT")
      {
       if (m_comboboxDistance.Select() == "Exact entry price")
        {
         openPrice = m_spinEditDistance.Value();
        }
       else 
        {
         openPrice = Bid + pendDist * _point;
        }
       if (openPrice <= Bid)
        {
         Alert ("Can't place pending order. Wrong entry price.");
         return;
        }
       // open Price is correct
       if (m_comboboxTakeProfit.Select() == "Take Profit at price")
        {
         TakeProfit = NormalizeDouble((openPrice - m_spinEditTakeProfit.Value()) / _point, digitsAfterDot);
         if (TakeProfit < 0) 
          {
           Alert ("Take Profit can't be set at ", m_spinEditTakeProfit.Value());
           return;
          }
        }
       else if (m_comboboxTakeProfit.Select() == "Take Profit at seconds")
        {
         TakeProfit = 0;
        }
       if (m_comboboxStopLoss.Select() == "Stop Loss at price")
        {
         StopLoss = NormalizeDouble((m_spinEditStopLoss.Value() - openPrice) / _point, digitsAfterDot);
         if (StopLoss < 0)
          {
           Alert ("Stop Loss can't be set at ", m_spinEditStopLoss.Value());
           return;
          }
        }
       if(m_comboboxLotSizeDropdown.Select() == "Risk (%)")
        {
         riskPers = m_spinEditLotSize.Value();
         riskUsd = riskPers * AccountEquity() / 100;
         lot = riskLotCalculation(riskPers, StopLoss);
        }
       else if(m_comboboxLotSizeDropdown.Select() == "Risk in USD ($)")
        {
         riskUsd = m_spinEditLotSize.Value();
         riskPers = riskUsd / AccountEquity() * 100;
         lot = riskLotCalculation(riskPers, StopLoss);
        }  
       int ticket = openSellLimit(openPrice);  
       datetime expir = 0;
  //     if (m_comboboxTakeProfit.Select() == "Take Profit at seconds") expir = TimeCurrent() + datetime(m_spinEditTakeProfit.Value());
       addNewTrade(ticket, m_spinEditTrailingStop.Value(), m_spinEditTrailingStopDistance.Value(), m_spinEditBreakeven.Value(), expir);
       checkTrades();
      }
      
      
      
     if (m_comboboxPendingType.Select() == "BUY&SELL (Straddle)")
      {
// BUY STOP
        {
         openPrice = Ask + pendDist * _point;
        }
       if (m_comboboxTakeProfit.Select() == "Take Profit at price")
        {
         TakeProfit = NormalizeDouble((m_spinEditTakeProfit.Value() - openPrice) / _point, digitsAfterDot);
         if (TakeProfit < 0) 
          {
           Alert ("Take Profit can't be set at ", m_spinEditTakeProfit.Value());
           return;
          }
        }
       else if (m_comboboxTakeProfit.Select() == "Take Profit at seconds")
        {
         TakeProfit = 0;
        }
       if (m_comboboxStopLoss.Select() == "Stop Loss at price")
        {
         StopLoss = NormalizeDouble((openPrice - m_spinEditStopLoss.Value()) / _point, digitsAfterDot);
         if (StopLoss < 0)
          {
           Alert ("Stop Loss can't be set at ", m_spinEditStopLoss.Value());
           return;
          }
        }
       if(m_comboboxLotSizeDropdown.Select() == "Risk (%)")
        {
         riskPers = m_spinEditLotSize.Value();
         riskUsd = riskPers * AccountEquity() / 100;
         lot = riskLotCalculation(riskPers, StopLoss);
        }
       else if(m_comboboxLotSizeDropdown.Select() == "Risk in USD ($)")
        {
         riskUsd = m_spinEditLotSize.Value();
         riskPers = riskUsd / AccountEquity() * 100;
         lot = riskLotCalculation(riskPers, StopLoss);
        }  
       int ticket = openBuyStop(openPrice);
       datetime expir = 0;
  //     if (m_comboboxTakeProfit.Select() == "Take Profit at seconds") expir = TimeCurrent() + datetime(m_spinEditTakeProfit.Value());
       addNewTrade(ticket, m_spinEditTrailingStop.Value(), m_spinEditTrailingStopDistance.Value(), m_spinEditBreakeven.Value(), expir);
   
// SELL STOP
        {
         openPrice = Bid - pendDist * _point;
        }
       if (m_comboboxTakeProfit.Select() == "Take Profit at price")
        {
         TakeProfit = NormalizeDouble((openPrice - m_spinEditTakeProfit.Value()) / _point, digitsAfterDot);
         if (TakeProfit < 0) 
          {
           Alert ("Take Profit can't be set at ", m_spinEditTakeProfit.Value());
           return;
          }
        }
       else if (m_comboboxTakeProfit.Select() == "Take Profit at seconds")
        {
         TakeProfit = 0;
        }
       if (m_comboboxStopLoss.Select() == "Stop Loss at price")
        {
         StopLoss = NormalizeDouble((m_spinEditStopLoss.Value() - openPrice) / _point, digitsAfterDot);
         if (StopLoss < 0)
          {
           Alert ("Stop Loss can't be set at ", m_spinEditStopLoss.Value());
           return;
          }
        }
       if(m_comboboxLotSizeDropdown.Select() == "Risk (%)")
        {
         riskPers = m_spinEditLotSize.Value();
         riskUsd = riskPers * AccountEquity() / 100;
         lot = riskLotCalculation(riskPers, StopLoss);
        }
       else if(m_comboboxLotSizeDropdown.Select() == "Risk in USD ($)")
        {
         riskUsd = m_spinEditLotSize.Value();
         riskPers = riskUsd / AccountEquity() * 100;
         lot = riskLotCalculation(riskPers, StopLoss);
        }  
       ticket = openSellStop(openPrice);
       expir = 0;
  //     if (m_comboboxTakeProfit.Select() == "Take Profit at seconds") expir = TimeCurrent() + datetime(m_spinEditTakeProfit.Value());
       addNewTrade(ticket, m_spinEditTrailingStop.Value(), m_spinEditTrailingStopDistance.Value(), m_spinEditBreakeven.Value(), expir);
       checkTrades();
      }
     refreshMoreActionsButtons();
    }
  }
//+------------------------------------------------------------------+
//| Event handler Radio On Actions                                   |
//+------------------------------------------------------------------+
void CPanelDialog::OnChangeRadioOn(void)
  {
   if (tradeMode)
    {
     m_radioOff.State(false);
     
     m_labelLossOnSL.Show();
     m_labelLossOnSLValue.Show();
     m_labelProfitOnTP.Show();
     m_labelProfitOnTPValue.Show();
     m_labelLotSize1.Show();
     m_labelLotSize1Value.Show();
     m_labelMargin.Show();
     m_labelMarginValue.Show();
     
     calculateTrade();

    }
  }
//+------------------------------------------------------------------+
//| Event handler Radio Off Actions                                  |
//+------------------------------------------------------------------+
void CPanelDialog::OnChangeRadioOff(void)
  {
   if (tradeMode)
    {
     m_radioOn.State(false);
     ObjectDelete(0, openPriceLine);
     ObjectDelete(0, openPriceLabel);
     ObjectDelete(0, slLine);
     ObjectDelete(0, tpLine);
     
     m_labelLossOnSL.Hide();
     m_labelLossOnSLValue.Hide();
     m_labelProfitOnTP.Hide();
     m_labelProfitOnTPValue.Hide();
     m_labelLotSize1.Hide();
     m_labelLotSize1Value.Hide();
     m_labelMargin.Hide();
     m_labelMarginValue.Hide();

    }
  }
//+------------------------------------------------------------------+
//| Event handler Combobox Stop Loss 2                               |
//+------------------------------------------------------------------+
void CPanelDialog::OnChangeComboSL(void)
  {
   int ticket = int(m_comboboxSelectOrder.Value());
   int orderType = 0;
   double orderOpenPrice = 0;
   double orderTP = 0;
   double orderSL = 0;
   double SLpips = 0;
   
   if (OrderSelect(ticket, SELECT_BY_TICKET))
    {
     orderType = OrderType();
     orderOpenPrice = OrderOpenPrice();
     orderTP = OrderTakeProfit();
     orderSL = OrderStopLoss();
    }
   if (orderType == OP_BUY || orderType == OP_BUYLIMIT || orderType == OP_BUYSTOP) 
    {
     if (orderSL == 0) SLpips = 0;
     else SLpips = (orderOpenPrice - orderSL) / _point;
    }
   else 
    {
     if (orderSL == 0) SLpips = 0;
     else SLpips = (orderSL - orderOpenPrice) / _point;
    }
    
   if (m_comboboxSL.Select() == "Stop Loss in pips")
    {
     m_spinEditSL.MaxValue(100000);
     m_spinEditSL.setDigits(digitsAfterDot);
     m_spinEditSL.Value(SLpips);
    }
   else if (m_comboboxSL.Select() == "Stop Loss at price")
    {
     m_spinEditSL.MaxValue(int(orderOpenPrice * 2));
     m_spinEditSL.setDigits(Digits);
     m_spinEditSL.Value(orderSL);
    }
   if (m_radioOn.State()) calculateTrade();
  }
//+------------------------------------------------------------------+
//| Event handler Combobox Take Profit 2                             |
//+------------------------------------------------------------------+
void CPanelDialog::OnChangeComboTP(void)
  {
   int ticket = int(m_comboboxSelectOrder.Value());
   int orderType = 0;
   double orderOpenPrice = 0;
   double orderTP = 0;
   double orderSL = 0;
   double TPpips = 0;
   int orderExpire = 0;
   
   if (OrderSelect(ticket, SELECT_BY_TICKET))
    {
     orderType = OrderType();
     orderOpenPrice = OrderOpenPrice();
     orderTP = OrderTakeProfit();
     orderSL = OrderStopLoss();
    }
   if (orderType == OP_BUY || orderType == OP_BUYLIMIT || orderType == OP_BUYSTOP) 
    {
     if (orderTP == 0) TPpips = 0;
     else TPpips = (orderTP - orderOpenPrice) / _point;
    }
   else 
    {
     if (orderTP == 0) TPpips = 0;
     else TPpips = (orderOpenPrice - orderTP) / _point;
    }

   if (m_comboboxTP.Select() == "Take Profit in pips")
    {
     m_spinEditTP.MaxValue(100000);
     m_spinEditTP.setDigits(digitsAfterDot);
     m_spinEditTP.Value(TPpips);
    }
   else if (m_comboboxTP.Select() == "Take Profit at price")
    {
     m_spinEditTP.MaxValue(int(orderOpenPrice * 2));
     m_spinEditTP.setDigits(Digits);
     m_spinEditTP.Value(orderTP);
    }
   else if (m_comboboxTP.Select() == "Take Profit at seconds")
    {
     for (int j = 0; j < ArraySize(tickets); j++)
      {
       if (tickets[j] == ticket)
        {
         orderExpire = int (expire[j] - TimeCurrent());
         break;
        }
      }

     m_spinEditTP.MaxValue(1000000);
     m_spinEditTP.setDigits(0);
     m_spinEditTP.Value(orderExpire);
    }
   if (m_radioOn.State()) calculateTrade();
  }
//+------------------------------------------------------------------+
//| Event handler Button Modify Order                                |
//+------------------------------------------------------------------+
void CPanelDialog::OnClickButtonModifyOrder(void)
  {
  /*
   if (m_buttonModifyTrade.Pressed())
    {
     
     int ticket = int(m_comboboxSelectOrder.Value());
     double orderOpenPrice = 0;
     int orderType = 0;
     double newSL = 0;
     double newTP = 0;
   
     if (OrderSelect(ticket, SELECT_BY_TICKET))
      {
       orderType = OrderType();

       orderOpenPrice = m_spinEditOpenPrice2.Value();
// Stop Loss
       if (m_comboboxSL.Select() == "Stop Loss at price")
        {
         newSL = m_spinEditSL.Value();
        }
       else 
        {
         if (orderType == OP_BUY || orderType == OP_BUYLIMIT || orderType == OP_BUYSTOP) 
          {
           newSL = orderOpenPrice - m_spinEditSL.Value() * _point;
          }
         else
          {
           newSL = orderOpenPrice + m_spinEditSL.Value() * _point;
          }
        }
// Take profit
       if (m_comboboxTP.Select() == "Take Profit at price")
        {
         newTP = m_spinEditTP.Value();
        }
       else if (m_comboboxTP.Select() == "Take Profit in pips")
        {
         if (orderType == OP_BUY || orderType == OP_BUYLIMIT || orderType == OP_BUYSTOP) 
          {
           newTP = orderOpenPrice + m_spinEditTP.Value() * _point;
          }
         else
          {
           newTP = orderOpenPrice - m_spinEditTP.Value() * _point;
          }
        }
       else
        {
         for (int j = 0; j < ArraySize(tickets); j++)
          {
           if (tickets[j] == ticket)
            {
             expire[j] = datetime (TimeCurrent() + m_spinEditTP.Value());
             break;
            }
          }
        }
      }
     checkTrades();
    }
    */
  }
//+------------------------------------------------------------------+
//| Event handler Button Close 50%                                   |
//+------------------------------------------------------------------+
void CPanelDialog::OnClickButtonClose50(void)
  {
   if (!tradeMode)
    {
     int ticket = int(m_comboboxSelectOrder.Value());
     if (OrderSelect(ticket, SELECT_BY_TICKET))
      {
       double closingVolume = NormalizeDouble (OrderLots() / 2, lotsDigits);
       Print ("Trying to close 50% of volume.");
       int Ans = OrderClose(OrderTicket(), closingVolume, OrderClosePrice(), Slippage);
       if (Ans)
        {
         Alert (_Symbol, ": Closing of 50% is successful.");
         
// Find New Order
         for (int i = OrdersTotal()-1; i >= 0; i--)
          {
           if (!OrderSelect(i,SELECT_BY_POS)) continue;
           if (OrderSymbol() != _Symbol) continue;
           if (OrderMagicNumber() != magic) continue;
           if (OrderType() == OP_BUY || OrderType() == OP_SELL)
            {
             string orderComment = OrderComment();
             int arrSize = ArraySize(tickets);
  
             for (int j = 0; j < arrSize; j++)
              {
               if (StringFind (orderComment, IntegerToString(tickets[j])) > -1)
                {
                 int oldTicket = tickets[j];
                 tickets[j] = OrderTicket();
                 Alert ("Old ticket: ", oldTicket, ", New ticket: ", tickets[j]);
                 m_comboboxSelectOrder.Select(0);
                 m_comboboxSelectOrder.AddItem(IntegerToString(tickets[j]) + "  " + ordersType(OrderType()) + " #" + _Symbol, tickets[j]);
                 m_comboboxSelectOrder.Select(tickets[j]);
                 
                 break;
                }
              }
            }
          }
        }
       else
        {
         Alert (_Symbol, ": Failed to close 50% of volume.");
        }
      }
  
     checkTrades();
    }
  }
//+------------------------------------------------------------------+
//| Event handler Button Close                                       |
//+------------------------------------------------------------------+
void CPanelDialog::OnClickButtonClose11(void)
  {
   if (!tradeMode)
    {
     int ticket = int(m_comboboxSelectOrder.Value());
     if (OrderSelect(ticket, SELECT_BY_TICKET))
      {
       int Ans = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage);
       if (Ans)
        {
         Alert (_Symbol, ": Closed successfully.");
         
         m_comboboxSelectOrder.Select(0);
                 
        }
       else
        {
         Alert (_Symbol, ": Failed.");
        }
      }
    }

   checkTrades();
  }
//+------------------------------------------------------------------+
//| Event handler Button Delete                                      |
//+------------------------------------------------------------------+
void CPanelDialog::OnClickButtonDelete(void)
  {
   if (!tradeMode)
    {
     int ticket = int(m_comboboxSelectOrder.Value());
     if (OrderSelect(ticket, SELECT_BY_TICKET))
      {
       int Ans = OrderDelete(OrderTicket());
       if (Ans)
        {
         Alert (_Symbol, ": Deleted successfully.");
         
         m_comboboxSelectOrder.Select(0);
                 
        }
       else
        {
         Alert (_Symbol, ": Failed.");
        }
      }
    }
   checkTrades();
  }
//+------------------------------------------------------------------+
//| Rest events handler                                              |
//+------------------------------------------------------------------+
bool CPanelDialog::OnDefault(const int id,const long &lparam,const double &dparam,const string &sparam)
  {
//--- let's handle event by parent
   return(false);
  }

//-------------------------------------------------

